
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         sparql_parser_parse
#define yylex           sparql_parser_lex
#define yyerror         sparql_parser_error
#define yylval          sparql_parser_lval
#define yychar          sparql_parser_char
#define yydebug         sparql_parser_debug
#define yynerrs         sparql_parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */


#ifdef HAVE_CONFIG_H
#include <rasqal_config.h>
#endif

#ifdef WIN32
#include <win32_rasqal_config.h>
#endif

#include <stdio.h>
#include <stdarg.h>

#include <rasqal.h>
#include <rasqal_internal.h>

#include <sparql_parser.h>

#define YY_DECL int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t yyscanner)
#define YY_NO_UNISTD_H 1
#include <sparql_lexer.h>

#include <sparql_common.h>


#if 0
#undef RASQAL_DEBUG
#define RASQAL_DEBUG 2
#endif


#define DEBUG_FH stderr

/* Make verbose error messages for syntax errors */
#define YYERROR_VERBOSE 1

/* Fail with an debug error message if RASQAL_DEBUG > 1 */
#if RASQAL_DEBUG > 1
#define YYERROR_MSG(msg) do { fputs("** YYERROR ", DEBUG_FH); fputs(msg, DEBUG_FH); fputc('\n', DEBUG_FH); YYERROR; } while(0)
#else
#define YYERROR_MSG(ignore) YYERROR
#endif

/* Slow down the grammar operation and watch it work */
#if RASQAL_DEBUG > 2
#define YYDEBUG 1
#endif

/* the lexer does not seem to track this */
#undef RASQAL_SPARQL_USE_ERROR_COLUMNS

/* Missing sparql_lexer.c/h prototypes */
int sparql_lexer_get_column(yyscan_t yyscanner);
/* Not used here */
/* void sparql_lexer_set_column(int  column_no , yyscan_t yyscanner);*/


/* What the lexer wants */
extern int sparql_lexer_lex (YYSTYPE *sparql_parser_lval, yyscan_t scanner);
#define YYLEX_PARAM ((rasqal_sparql_query_language*)(((rasqal_query*)rq)->context))->scanner

/* Pure parser argument (a void*) */
#define YYPARSE_PARAM rq

/* Make the yyerror below use the rdf_parser */
#undef yyerror
#define yyerror(message) sparql_query_error((rasqal_query*)rq, message)

/* Make lex/yacc interface as small as possible */
#undef yylex
#define yylex sparql_lexer_lex


static int sparql_parse(rasqal_query* rq);
static void sparql_query_error(rasqal_query* rq, const char *message);
static void sparql_query_error_full(rasqal_query *rq, const char *message, ...) RASQAL_PRINTF_FORMAT(2, 3);



/* Line 189 of yacc.c  */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     SELECT = 258,
     FROM = 259,
     WHERE = 260,
     OPTIONAL = 261,
     DESCRIBE = 262,
     CONSTRUCT = 263,
     ASK = 264,
     DISTINCT = 265,
     REDUCED = 266,
     LIMIT = 267,
     UNION = 268,
     PREFIX = 269,
     BASE = 270,
     BOUND = 271,
     GRAPH = 272,
     NAMED = 273,
     FILTER = 274,
     OFFSET = 275,
     ORDER = 276,
     BY = 277,
     REGEX = 278,
     ASC = 279,
     DESC = 280,
     LANGMATCHES = 281,
     A = 282,
     STR = 283,
     LANG = 284,
     DATATYPE = 285,
     ISURI = 286,
     ISBLANK = 287,
     ISLITERAL = 288,
     SAMETERM = 289,
     EXPLAIN = 290,
     GROUP = 291,
     COUNT = 292,
     SUM = 293,
     AVG = 294,
     MIN = 295,
     MAX = 296,
     AS = 297,
     DELETE = 298,
     INSERT = 299,
     LET = 300,
     COALESCE = 301,
     SC_OR = 302,
     SC_AND = 303,
     EQ = 304,
     NEQ = 305,
     LT = 306,
     GT = 307,
     LE = 308,
     GE = 309,
     ASSIGN = 310,
     STRING_LITERAL = 311,
     DOUBLE_LITERAL = 312,
     DOUBLE_POSITIVE_LITERAL = 313,
     DOUBLE_NEGATIVE_LITERAL = 314,
     INTEGER_LITERAL = 315,
     INTEGER_POSITIVE_LITERAL = 316,
     INTEGER_NEGATIVE_LITERAL = 317,
     DECIMAL_LITERAL = 318,
     DECIMAL_POSITIVE_LITERAL = 319,
     DECIMAL_NEGATIVE_LITERAL = 320,
     BOOLEAN_LITERAL = 321,
     URI_LITERAL = 322,
     URI_LITERAL_BRACE = 323,
     QNAME_LITERAL = 324,
     QNAME_LITERAL_BRACE = 325,
     BLANK_LITERAL = 326,
     IDENTIFIER = 327
   };
#endif
/* Tokens.  */
#define SELECT 258
#define FROM 259
#define WHERE 260
#define OPTIONAL 261
#define DESCRIBE 262
#define CONSTRUCT 263
#define ASK 264
#define DISTINCT 265
#define REDUCED 266
#define LIMIT 267
#define UNION 268
#define PREFIX 269
#define BASE 270
#define BOUND 271
#define GRAPH 272
#define NAMED 273
#define FILTER 274
#define OFFSET 275
#define ORDER 276
#define BY 277
#define REGEX 278
#define ASC 279
#define DESC 280
#define LANGMATCHES 281
#define A 282
#define STR 283
#define LANG 284
#define DATATYPE 285
#define ISURI 286
#define ISBLANK 287
#define ISLITERAL 288
#define SAMETERM 289
#define EXPLAIN 290
#define GROUP 291
#define COUNT 292
#define SUM 293
#define AVG 294
#define MIN 295
#define MAX 296
#define AS 297
#define DELETE 298
#define INSERT 299
#define LET 300
#define COALESCE 301
#define SC_OR 302
#define SC_AND 303
#define EQ 304
#define NEQ 305
#define LT 306
#define GT 307
#define LE 308
#define GE 309
#define ASSIGN 310
#define STRING_LITERAL 311
#define DOUBLE_LITERAL 312
#define DOUBLE_POSITIVE_LITERAL 313
#define DOUBLE_NEGATIVE_LITERAL 314
#define INTEGER_LITERAL 315
#define INTEGER_POSITIVE_LITERAL 316
#define INTEGER_NEGATIVE_LITERAL 317
#define DECIMAL_LITERAL 318
#define DECIMAL_POSITIVE_LITERAL 319
#define DECIMAL_NEGATIVE_LITERAL 320
#define BOOLEAN_LITERAL 321
#define URI_LITERAL 322
#define URI_LITERAL_BRACE 323
#define QNAME_LITERAL 324
#define QNAME_LITERAL_BRACE 325
#define BLANK_LITERAL 326
#define IDENTIFIER 327




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */


  raptor_sequence *seq;
  rasqal_variable *variable;
  rasqal_literal *literal;
  rasqal_triple *triple;
  rasqal_expression *expr;
  rasqal_graph_pattern *graph_pattern;
  double floating;
  raptor_uri *uri;
  unsigned char *name;
  rasqal_formula *formula;



/* Line 214 of yacc.c  */

} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */


#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  6
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   817

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  89
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  94
/* YYNRULES -- Number of rules.  */
#define YYNRULES  210
/* YYNRULES -- Number of states.  */
#define YYNSTATES  363

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   327

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    88,     2,     2,    55,     2,     2,     2,
      48,    49,    66,    64,    47,    65,    86,    67,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    87,
       2,     2,     2,    54,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    51,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    52,     2,    53,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    56,    57,    58,    59,    60,    61,    62,    63,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,     9,    10,    12,    14,    16,    18,
      20,    22,    25,    28,    29,    34,    35,    42,    49,    55,
      57,    59,    62,    66,    68,    70,    74,    76,    80,    84,
      86,    88,    90,    92,    94,    99,   104,   109,   114,   119,
     124,   130,   136,   142,   145,   149,   151,   155,   159,   163,
     167,   171,   172,   174,   177,   179,   182,   184,   186,   187,
     191,   195,   196,   199,   202,   204,   206,   207,   211,   212,
     215,   217,   220,   223,   225,   227,   229,   231,   234,   237,
     242,   244,   245,   248,   250,   251,   255,   257,   259,   261,
     262,   266,   268,   270,   272,   274,   276,   279,   283,   287,
     289,   293,   295,   302,   305,   307,   309,   311,   315,   320,
     324,   326,   327,   331,   335,   337,   338,   341,   344,   348,
     351,   352,   354,   355,   358,   361,   362,   364,   366,   368,
     370,   372,   376,   380,   383,   385,   387,   389,   391,   393,
     395,   397,   400,   403,   405,   407,   409,   411,   413,   415,
     418,   420,   424,   426,   430,   432,   436,   440,   444,   448,
     452,   456,   458,   462,   466,   469,   472,   474,   478,   482,
     484,   487,   490,   493,   495,   497,   499,   501,   503,   505,
     509,   514,   519,   526,   531,   536,   543,   548,   553,   558,
     560,   562,   569,   578,   580,   582,   584,   586,   588,   590,
     592,   594,   596,   598,   600,   602,   604,   606,   608,   610,
     612
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      90,     0,    -1,    93,    91,    92,    -1,    35,    -1,    -1,
      96,    -1,   107,    -1,   108,    -1,   110,    -1,   111,    -1,
     112,    -1,    94,    95,    -1,    15,    80,    -1,    -1,    95,
      14,    85,    80,    -1,    -1,     3,    10,    97,   113,   117,
     119,    -1,     3,    11,    97,   113,   117,   119,    -1,     3,
      97,   113,   117,   119,    -1,    98,    -1,    66,    -1,    98,
      99,    -1,    98,    47,    99,    -1,    99,    -1,   162,    -1,
     100,    42,   163,    -1,   101,    -1,    48,   101,    49,    -1,
      48,   165,    49,    -1,   102,    -1,   103,    -1,   104,    -1,
     105,    -1,   106,    -1,    37,    48,   165,    49,    -1,    37,
      48,    66,    49,    -1,    38,    48,   165,    49,    -1,    39,
      48,   165,    49,    -1,    40,    48,   165,    49,    -1,    41,
      48,   165,    49,    -1,     8,   145,   113,   117,   119,    -1,
       7,   109,   113,   118,   119,    -1,     7,    66,   113,   118,
     119,    -1,   109,   161,    -1,   109,    47,   161,    -1,   161,
      -1,     9,   113,   117,    -1,    43,   113,   118,    -1,    44,
     113,   118,    -1,   113,     4,   114,    -1,   113,     4,   115,
      -1,    -1,   116,    -1,    18,   116,    -1,   181,    -1,     5,
     127,    -1,   127,    -1,   117,    -1,    -1,   120,   122,   121,
      -1,    36,    22,   123,    -1,    -1,   125,   126,    -1,   126,
     125,    -1,   125,    -1,   126,    -1,    -1,    21,    22,   123,
      -1,    -1,   123,   124,    -1,   124,    -1,    24,   173,    -1,
      25,   173,    -1,   142,    -1,   162,    -1,   173,    -1,   174,
      -1,    12,    73,    -1,    20,    73,    -1,    52,   128,   129,
      53,    -1,   133,    -1,    -1,   129,   130,    -1,   130,    -1,
      -1,   131,   132,   128,    -1,   134,    -1,   140,    -1,    86,
      -1,    -1,   147,    86,   128,    -1,   147,    -1,   135,    -1,
     137,    -1,   136,    -1,   139,    -1,     6,   127,    -1,    17,
     161,   127,    -1,   127,    13,   138,    -1,   127,    -1,   138,
      13,   127,    -1,   127,    -1,    45,    48,   162,    68,   165,
      49,    -1,    19,   141,    -1,   173,    -1,   174,    -1,   142,
      -1,   176,   144,    49,    -1,    46,    48,   144,    49,    -1,
     144,    47,   165,    -1,   165,    -1,    -1,    52,   146,    53,
      -1,   147,    86,   146,    -1,   147,    -1,    -1,   160,   148,
      -1,   155,   150,    -1,   154,   151,   149,    -1,    87,   150,
      -1,    -1,   148,    -1,    -1,   153,   152,    -1,    47,   151,
      -1,    -1,   159,    -1,   161,    -1,    27,    -1,   157,    -1,
     156,    -1,    50,   148,    51,    -1,    48,   158,    49,    -1,
     158,   159,    -1,   159,    -1,   160,    -1,   155,    -1,   162,
      -1,   164,    -1,   162,    -1,   181,    -1,    54,   163,    -1,
      55,   163,    -1,    85,    -1,   181,    -1,    69,    -1,   177,
      -1,    79,    -1,   182,    -1,    48,    49,    -1,   166,    -1,
     166,    56,   167,    -1,   167,    -1,   167,    57,   168,    -1,
     168,    -1,   169,    58,   169,    -1,   169,    59,   169,    -1,
     169,    60,   169,    -1,   169,    61,   169,    -1,   169,    62,
     169,    -1,   169,    63,   169,    -1,   169,    -1,   170,    64,
     169,    -1,   170,    65,   169,    -1,   170,   179,    -1,   170,
     180,    -1,   170,    -1,   171,    66,   170,    -1,   171,    67,
     170,    -1,   171,    -1,    88,   172,    -1,    64,   172,    -1,
      65,   172,    -1,   172,    -1,   173,    -1,   174,    -1,   142,
      -1,   164,    -1,   162,    -1,    48,   165,    49,    -1,    28,
      48,   165,    49,    -1,    29,    48,   165,    49,    -1,    26,
      48,   165,    47,   165,    49,    -1,    30,    48,   165,    49,
      -1,    16,    48,   162,    49,    -1,    34,    48,   165,    47,
     165,    49,    -1,    31,    48,   165,    49,    -1,    32,    48,
     165,    49,    -1,    33,    48,   165,    49,    -1,   175,    -1,
     143,    -1,    23,    48,   165,    47,   165,    49,    -1,    23,
      48,   165,    47,   165,    47,   165,    49,    -1,    81,    -1,
      83,    -1,   178,    -1,   179,    -1,   180,    -1,    73,    -1,
      76,    -1,    70,    -1,    74,    -1,    77,    -1,    71,    -1,
      75,    -1,    78,    -1,    72,    -1,    80,    -1,    82,    -1,
      84,    -1,    50,    51,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   334,   334,   340,   350,   357,   362,   367,   372,   376,
     380,   388,   396,   401,   408,   440,   447,   453,   459,   470,
     474,   485,   494,   503,   521,   525,   546,   550,   554,   561,
     565,   569,   573,   577,   584,   597,   616,   633,   650,   667,
     685,   694,   699,   708,   717,   726,   741,   750,   762,   774,
     775,   776,   781,   797,   813,   821,   825,   833,   834,   839,
     844,   868,   873,   874,   875,   876,   878,   884,   892,   897,
     907,   926,   932,   938,   945,   961,   968,   979,   995,  1013,
    1070,  1084,  1096,  1133,  1138,  1150,  1197,  1210,  1238,  1239,
    1244,  1275,  1283,  1287,  1291,  1295,  1303,  1341,  1390,  1405,
    1412,  1422,  1446,  1466,  1474,  1478,  1482,  1490,  1525,  1547,
    1557,  1573,  1580,  1588,  1617,  1629,  1639,  1682,  1729,  1824,
    1829,  1836,  1841,  1848,  1925,  1930,  1937,  1945,  1955,  1990,
    1994,  2002,  2068,  2209,  2259,  2295,  2299,  2307,  2319,  2332,
    2338,  2346,  2350,  2357,  2368,  2372,  2376,  2380,  2384,  2388,
    2401,  2409,  2415,  2423,  2430,  2439,  2445,  2451,  2457,  2463,
    2469,  2475,  2484,  2490,  2496,  2507,  2518,  2525,  2531,  2537,
    2545,  2551,  2555,  2561,  2575,  2579,  2583,  2592,  2598,  2611,
    2619,  2625,  2631,  2637,  2643,  2657,  2663,  2669,  2675,  2681,
    2685,  2693,  2699,  2712,  2718,  2737,  2741,  2745,  2752,  2756,
    2760,  2768,  2772,  2776,  2784,  2788,  2792,  2804,  2810,  2829,
    2834
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "SELECT", "FROM", "WHERE", "OPTIONAL",
  "DESCRIBE", "CONSTRUCT", "ASK", "DISTINCT", "REDUCED", "LIMIT", "UNION",
  "PREFIX", "BASE", "BOUND", "GRAPH", "NAMED", "FILTER", "OFFSET", "ORDER",
  "BY", "REGEX", "ASC", "DESC", "LANGMATCHES", "\"a\"", "\"str\"",
  "\"lang\"", "\"datatype\"", "\"isUri\"", "\"isBlank\"", "\"isLiteral\"",
  "\"sameTerm\"", "EXPLAIN", "GROUP", "COUNT", "SUM", "AVG", "MIN", "MAX",
  "AS", "DELETE", "INSERT", "LET", "COALESCE", "','", "'('", "')'", "'['",
  "']'", "'{'", "'}'", "'?'", "'$'", "SC_OR", "SC_AND", "EQ", "NEQ", "LT",
  "GT", "LE", "GE", "'+'", "'-'", "'*'", "'/'", "\":=\"",
  "\"string literal\"", "\"double literal\"",
  "\"double positive literal\"", "\"double negative literal\"",
  "\"integer literal\"", "\"integer positive literal\"",
  "\"integer negative literal\"", "\"decimal literal\"",
  "\"decimal positive literal\"", "\"decimal negative literal\"",
  "\"boolean literal\"", "\"URI literal\"", "\"URI literal (\"",
  "\"QName literal\"", "\"QName literal (\"", "\"blank node literal\"",
  "\"identifier\"", "'.'", "';'", "'!'", "$accept", "Query", "ExplainOpt",
  "ReportFormat", "Prologue", "BaseDeclOpt", "PrefixDeclListOpt",
  "SelectQuery", "SelectExpressionList", "SelectExpressionListTail",
  "SelectTerm", "SelectExpression", "AggregateExpression",
  "CountAggregateExpression", "SumAggregateExpression",
  "AvgAggregateExpression", "MinAggregateExpression",
  "MaxAggregateExpression", "ConstructQuery", "DescribeQuery",
  "VarOrIRIrefList", "AskQuery", "DeleteQuery", "InsertQuery",
  "DatasetClauseListOpt", "DefaultGraphClause", "NamedGraphClause",
  "SourceSelector", "WhereClause", "WhereClauseOpt", "SolutionModifier",
  "GroupClauseOpt", "LimitOffsetClausesOpt", "OrderClauseOpt",
  "OrderConditionList", "OrderCondition", "LimitClause", "OffsetClause",
  "GroupGraphPattern", "TriplesBlockOpt", "GraphPatternListOpt",
  "GraphPatternList", "GraphPatternListFilter", "DotOptional",
  "TriplesBlock", "GraphPatternNotTriples", "OptionalGraphPattern",
  "GraphGraphPattern", "GroupOrUnionGraphPattern",
  "GroupOrUnionGraphPatternList", "LetGraphPattern", "Filter",
  "Constraint", "FunctionCall", "CoalesceExpression", "ArgList",
  "ConstructTemplate", "ConstructTriplesOpt", "TriplesSameSubject",
  "PropertyListNotEmpty", "PropertyListTailOpt", "PropertyList",
  "ObjectList", "ObjectTail", "Object", "Verb", "TriplesNode",
  "BlankNodePropertyList", "Collection", "GraphNodeListNotEmpty",
  "GraphNode", "VarOrTerm", "VarOrIRIref", "Var", "VarName", "GraphTerm",
  "Expression", "ConditionalOrExpression", "ConditionalAndExpression",
  "RelationalExpression", "AdditiveExpression", "MultiplicativeExpression",
  "UnaryExpression", "PrimaryExpression", "BrackettedExpression",
  "BuiltInCall", "RegexExpression", "IRIrefBrace", "NumericLiteral",
  "NumericLiteralUnsigned", "NumericLiteralPositive",
  "NumericLiteralNegative", "IRIref", "BlankNode", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,    44,    40,    41,
      91,    93,   123,   125,    63,    36,   302,   303,   304,   305,
     306,   307,   308,   309,    43,    45,    42,    47,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,    46,    59,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    89,    90,    91,    91,    92,    92,    92,    92,    92,
      92,    93,    94,    94,    95,    95,    96,    96,    96,    97,
      97,    98,    98,    98,    99,    99,   100,   100,   100,   101,
     101,   101,   101,   101,   102,   102,   103,   104,   105,   106,
     107,   108,   108,   109,   109,   109,   110,   111,   112,   113,
     113,   113,   114,   115,   116,   117,   117,   118,   118,   119,
     120,   120,   121,   121,   121,   121,   121,   122,   122,   123,
     123,   124,   124,   124,   124,   124,   124,   125,   126,   127,
     128,   128,   129,   129,   129,   130,   131,   131,   132,   132,
     133,   133,   134,   134,   134,   134,   135,   136,   137,   137,
     138,   138,   139,   140,   141,   141,   141,   142,   143,   144,
     144,   144,   145,   146,   146,   146,   147,   147,   148,   149,
     149,   150,   150,   151,   152,   152,   153,   154,   154,   155,
     155,   156,   157,   158,   158,   159,   159,   160,   160,   161,
     161,   162,   162,   163,   164,   164,   164,   164,   164,   164,
     165,   166,   166,   167,   167,   168,   168,   168,   168,   168,
     168,   168,   169,   169,   169,   169,   169,   170,   170,   170,
     171,   171,   171,   171,   172,   172,   172,   172,   172,   173,
     174,   174,   174,   174,   174,   174,   174,   174,   174,   174,
     174,   175,   175,   176,   176,   177,   177,   177,   178,   178,
     178,   179,   179,   179,   180,   180,   180,   181,   181,   182,
     182
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     1,     0,     1,     1,     1,     1,     1,
       1,     2,     2,     0,     4,     0,     6,     6,     5,     1,
       1,     2,     3,     1,     1,     3,     1,     3,     3,     1,
       1,     1,     1,     1,     4,     4,     4,     4,     4,     4,
       5,     5,     5,     2,     3,     1,     3,     3,     3,     3,
       3,     0,     1,     2,     1,     2,     1,     1,     0,     3,
       3,     0,     2,     2,     1,     1,     0,     3,     0,     2,
       1,     2,     2,     1,     1,     1,     1,     2,     2,     4,
       1,     0,     2,     1,     0,     3,     1,     1,     1,     0,
       3,     1,     1,     1,     1,     1,     2,     3,     3,     1,
       3,     1,     6,     2,     1,     1,     1,     3,     4,     3,
       1,     0,     3,     3,     1,     0,     2,     2,     3,     2,
       0,     1,     0,     2,     2,     0,     1,     1,     1,     1,
       1,     3,     3,     2,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     1,     1,     1,     1,     1,     1,     2,
       1,     3,     1,     3,     1,     3,     3,     3,     3,     3,
       3,     1,     3,     3,     2,     2,     1,     3,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     3,
       4,     4,     6,     4,     4,     6,     4,     4,     4,     1,
       1,     6,     8,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      13,     0,     0,     4,    15,    12,     1,     3,     0,    11,
       0,     0,     0,    51,    51,    51,     2,     5,     6,     7,
       8,     9,    10,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    20,    51,    19,    23,     0,    26,
      29,    30,    31,    32,    33,    24,    51,   207,   208,    51,
      45,   139,   140,   115,    51,     0,    58,    58,     0,    51,
      51,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   145,   200,   203,   206,   198,   201,   204,   199,   202,
     205,   147,   193,   194,   209,     0,     0,   176,   190,   178,
     177,     0,   150,   152,   154,   161,   166,   169,   173,   174,
     175,   189,   111,   146,   195,   196,   197,   144,   148,   143,
     141,   142,     0,     0,    21,     0,    58,     0,    58,    43,
       0,     0,     0,   114,   122,   130,   129,     0,   137,   138,
       0,     0,     0,    81,    46,    56,    57,    47,    48,    14,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   111,   149,
       0,   210,   171,   172,   170,    27,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   164,   165,     0,
       0,     0,   110,    61,    22,    25,    61,    44,    61,   136,
       0,   134,   135,   128,     0,     0,   127,   112,   115,   121,
     117,   116,    61,     0,    49,    50,    52,    54,    55,    84,
      80,    91,    61,    61,    35,    34,    36,    37,    38,    39,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   179,   151,   153,   155,   156,   157,   158,   159,   160,
     162,   163,   167,   168,     0,   107,     0,    18,    68,    42,
      41,   132,   133,   131,   120,   125,   126,   113,    40,    53,
       0,     0,     0,     0,    99,     0,    83,    89,    86,    92,
      94,    93,    95,    87,    81,    16,    17,   184,     0,     0,
     180,   181,   183,   186,   187,   188,     0,   108,   109,     0,
       0,    66,   122,   118,     0,   123,    96,     0,     0,   103,
     106,   104,   105,     0,     0,    79,    82,    88,    81,    90,
       0,     0,     0,     0,     0,    60,    70,    73,    74,    75,
      76,     0,     0,     0,    59,    64,    65,   119,   124,    97,
       0,   101,    98,    85,     0,   191,   182,   185,    71,    72,
      69,    67,    77,    78,    62,    63,     0,     0,     0,     0,
     100,   192,   102
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     8,    16,     3,     4,     9,    17,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    18,    19,
      49,    20,    21,    22,    55,   214,   215,   216,   146,   147,
     257,   258,   334,   301,   325,   326,   335,   336,   145,   219,
     275,   276,   277,   318,   220,   278,   279,   280,   281,   342,
     282,   283,   309,    97,    98,   191,    54,   132,   221,   209,
     303,   210,   264,   305,   265,   205,   134,   135,   136,   200,
     266,   137,   206,    99,   120,   100,   170,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -301
static const yytype_int16 yypact[] =
{
       3,   -53,    30,    -1,  -301,  -301,  -301,  -301,   177,    23,
     272,    43,    -2,  -301,  -301,  -301,  -301,  -301,  -301,  -301,
    -301,  -301,  -301,   -43,   751,   751,    12,    36,    56,    60,
      62,   320,    33,    33,  -301,  -301,   393,  -301,    86,  -301,
    -301,  -301,  -301,  -301,  -301,  -301,  -301,  -301,  -301,    14,
    -301,  -301,  -301,   703,  -301,    15,    15,    15,    58,  -301,
    -301,   389,   527,   527,   527,   527,   101,   112,   121,   124,
     128,   140,   143,   144,   145,   146,   148,   458,    27,   596,
     596,  -301,  -301,  -301,  -301,  -301,  -301,  -301,  -301,  -301,
    -301,  -301,  -301,  -301,  -301,   596,   150,  -301,  -301,  -301,
    -301,   151,   147,   162,  -301,   366,   583,   -20,  -301,  -301,
    -301,  -301,   527,  -301,  -301,  -301,  -301,  -301,  -301,  -301,
    -301,  -301,    15,   461,  -301,    33,    15,    61,    15,  -301,
     633,    -6,   149,   115,   107,  -301,  -301,   107,  -301,  -301,
      15,     6,   170,   703,  -301,  -301,  -301,  -301,  -301,  -301,
      15,    15,   174,   175,   176,   179,   182,   184,    91,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,  -301,
     185,  -301,  -301,  -301,  -301,  -301,  -301,   527,   527,   527,
     527,   527,   527,   527,   527,   527,   527,  -301,  -301,   527,
     527,   -14,  -301,   190,  -301,  -301,   190,  -301,   190,  -301,
     670,  -301,  -301,  -301,   186,   703,  -301,  -301,   703,  -301,
    -301,  -301,   190,    25,  -301,  -301,  -301,  -301,  -301,    95,
    -301,   152,   190,   190,  -301,  -301,  -301,  -301,  -301,  -301,
     191,   183,   194,   195,   199,   201,   209,   210,   211,   218,
      90,  -301,   162,  -301,  -301,  -301,  -301,  -301,  -301,  -301,
    -301,  -301,  -301,  -301,   527,  -301,   246,  -301,   249,  -301,
    -301,  -301,  -301,  -301,   188,   225,  -301,  -301,  -301,  -301,
     170,    61,   223,   228,   260,   125,  -301,   192,  -301,  -301,
    -301,  -301,  -301,  -301,   703,  -301,  -301,  -301,   527,   527,
    -301,  -301,  -301,  -301,  -301,  -301,   527,  -301,  -301,   181,
     255,    16,   107,  -301,   703,  -301,  -301,   170,   527,  -301,
    -301,  -301,  -301,    91,   170,  -301,  -301,  -301,   703,  -301,
     126,   237,   239,   242,   242,   181,  -301,  -301,  -301,  -301,
    -301,   181,   220,   222,  -301,   271,   284,  -301,  -301,  -301,
     230,  -301,   286,  -301,   527,  -301,  -301,  -301,  -301,  -301,
    -301,   181,  -301,  -301,  -301,  -301,   527,   170,   251,   252,
    -301,  -301,  -301
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -301,  -301,  -301,  -301,  -301,  -301,  -301,  -301,   141,  -301,
     -28,  -301,   276,  -301,  -301,  -301,  -301,  -301,  -301,  -301,
    -301,  -301,  -301,  -301,   270,  -301,  -301,    89,   -51,   -45,
      20,  -301,  -301,  -301,   -17,  -300,   -19,   -13,  -140,  -253,
    -301,    48,  -301,  -301,  -301,  -301,  -301,  -301,  -301,  -301,
    -301,  -301,  -301,  -259,  -301,   157,  -301,   110,   -44,  -108,
    -301,    26,    28,  -301,  -301,  -301,  -125,  -301,  -301,  -301,
    -113,  -123,    -8,   -10,   -23,   -37,    -9,  -301,   154,   155,
     197,    -7,  -301,   -22,  -261,  -240,  -301,  -301,  -301,  -301,
     231,   233,    -5,  -301
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint16 yytable[] =
{
      45,    51,   218,    50,   144,   199,    52,   202,   124,   133,
     121,   311,   148,   310,    45,    45,   139,   201,     1,   141,
     142,   203,   101,   204,   213,   350,    45,     5,   332,   211,
       6,   319,   312,   254,     7,   255,   333,    23,   329,    51,
     327,   129,    58,   138,    52,   171,   189,   190,    32,    33,
      53,   350,   153,   154,   155,   156,   157,   172,   173,   330,
      61,   127,   348,   349,   329,   343,   327,   143,    32,    33,
     329,   193,   327,   174,    47,   199,    48,   202,   171,   274,
     199,   196,   202,   198,    62,   330,    47,   262,    48,   212,
     329,   330,   327,   139,    47,   194,    48,    32,    33,   222,
     223,   270,   195,   192,    63,    47,   139,    48,    64,    46,
      65,   330,   271,    45,   272,    32,    33,    51,   119,   197,
     138,    51,    52,    47,    51,    48,    52,    51,   125,    52,
     306,   270,    52,   138,   203,   274,   217,   254,   149,   297,
     273,    47,   271,    48,   272,    32,    33,   143,   230,   158,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   192,
     159,    32,    33,   139,   133,    59,    60,   339,   139,   160,
     273,   139,   161,   344,   341,   345,   162,   143,   315,   199,
      10,   202,   252,   253,    11,    12,    13,    47,   163,    48,
     138,   164,   165,   166,   167,   138,   168,    66,   138,   175,
     176,   208,   207,   177,    67,   323,   324,    68,   217,    69,
      70,    71,    72,    73,    74,    75,   259,   360,   260,   178,
      14,    15,   143,   224,   225,   226,   256,    76,   227,   308,
     288,   228,   268,   229,   241,    32,    33,   263,   284,    66,
     287,   289,   285,   286,   290,   298,    67,   139,   291,    68,
     292,    69,    70,    71,    72,    73,    74,    75,   293,   294,
     295,    51,    92,   307,    93,   296,    52,   139,   299,    76,
     300,   308,   304,   314,   138,   302,   313,   331,   317,   320,
     321,   139,    24,    25,    56,    57,   346,   322,   347,   328,
     308,   333,    51,   352,   138,   353,   332,    52,   356,   357,
     361,   362,   269,   340,    92,   122,    93,    96,   138,    26,
      27,    28,    29,    30,   351,   328,   126,   355,   267,   128,
      31,   328,   354,   316,   140,   240,    32,    33,   337,   150,
     151,   242,   338,   243,     0,   358,    66,   187,    34,   188,
       0,   328,     0,    67,     0,     0,    68,   359,    69,    70,
      71,    72,    73,    74,    75,     0,     0,    26,    27,    28,
      29,    30,     0,     0,     0,     0,    76,     0,    77,     0,
      78,     0,     0,     0,    32,    33,   244,   245,   246,   247,
     248,   249,   250,   251,    79,    80,     0,     0,     0,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      47,    92,    48,    93,    94,    66,     0,     0,    95,     0,
       0,     0,    67,     0,     0,    68,     0,    69,    70,    71,
      72,    73,    74,    75,   179,   180,   181,   182,   183,   184,
      26,    27,    28,    29,    30,    76,     0,    77,     0,    78,
     123,    31,     0,    32,    33,     0,     0,    32,    33,     0,
       0,     0,     0,    79,    80,   152,     0,     0,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    47,
      92,    48,    93,    94,    66,     0,     0,    95,     0,     0,
       0,    67,     0,     0,    68,     0,    69,    70,    71,    72,
      73,    74,    75,     0,     0,     0,     0,     0,    26,    27,
      28,    29,    30,     0,    76,     0,    77,   169,    78,    31,
       0,     0,    32,    33,     0,    32,    33,     0,     0,     0,
       0,     0,    79,    80,     0,     0,     0,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    47,    92,
      48,    93,    94,    66,     0,     0,    95,     0,     0,     0,
      67,     0,     0,    68,     0,    69,    70,    71,    72,    73,
      74,    75,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,     0,    77,     0,    78,     0,     0,
       0,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,    79,    80,     0,     0,     0,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    47,    92,    48,
      93,    94,    66,     0,     0,    95,     0,     0,     0,    67,
       0,     0,    68,     0,    69,    70,    71,    72,    73,    74,
      75,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    76,     0,    77,     0,    78,   185,   186,     0,
      32,    33,     0,     0,    83,    84,     0,    86,    87,     0,
      89,    90,     0,     0,     0,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    47,    92,    48,    93,
      94,   130,   169,   131,     0,     0,     0,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    47,     0,    48,     0,    94,   130,   261,
     131,     0,     0,     0,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      47,   130,    48,   131,    94,     0,     0,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    47,     0,    48,     0,    94,    26,    27,
      28,    29,    30,     0,     0,     0,     0,     0,     0,    31,
       0,     0,     0,     0,     0,    32,    33,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    34
};

static const yytype_int16 yycheck[] =
{
      10,    11,   142,    11,    55,   130,    11,   130,    36,    53,
      33,   272,    57,   272,    24,    25,    53,   130,    15,     4,
       5,    27,    31,   131,    18,   325,    36,    80,    12,   137,
       0,   284,   272,    47,    35,    49,    20,    14,   299,    49,
     299,    49,    85,    53,    49,    51,    66,    67,    54,    55,
      52,   351,    61,    62,    63,    64,    65,    79,    80,   299,
      48,    47,   323,   324,   325,   318,   325,    52,    54,    55,
     331,   122,   331,    95,    80,   200,    82,   200,    51,   219,
     205,   126,   205,   128,    48,   325,    80,   200,    82,   140,
     351,   331,   351,   130,    80,   123,    82,    54,    55,   150,
     151,     6,   125,   112,    48,    80,   143,    82,    48,    66,
      48,   351,    17,   123,    19,    54,    55,   127,    85,   127,
     130,   131,   127,    80,   134,    82,   131,   137,    42,   134,
     270,     6,   137,   143,    27,   275,   141,    47,    80,    49,
      45,    80,    17,    82,    19,    54,    55,    52,   158,    48,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
      48,    54,    55,   200,   208,    24,    25,   307,   205,    48,
      45,   208,    48,    47,   314,    49,    48,    52,    53,   304,
       3,   304,   189,   190,     7,     8,     9,    80,    48,    82,
     200,    48,    48,    48,    48,   205,    48,    16,   208,    49,
      49,    86,    53,    56,    23,    24,    25,    26,   213,    28,
      29,    30,    31,    32,    33,    34,   196,   357,   198,    57,
      43,    44,    52,    49,    49,    49,    36,    46,    49,    48,
      47,    49,   212,    49,    49,    54,    55,    51,    86,    16,
      49,    47,   222,   223,    49,   254,    23,   284,    49,    26,
      49,    28,    29,    30,    31,    32,    33,    34,    49,    49,
      49,   271,    81,   271,    83,    47,   271,   304,    22,    46,
      21,    48,    47,    13,   284,    87,    48,    22,    86,   288,
     289,   318,    10,    11,    14,    15,    49,   296,    49,   299,
      48,    20,   302,    73,   304,    73,    12,   302,    68,    13,
      49,    49,   213,   313,    81,    35,    83,    31,   318,    37,
      38,    39,    40,    41,   331,   325,    46,   336,   208,    49,
      48,   331,   335,   275,    54,   168,    54,    55,   302,    59,
      60,   177,   304,   178,    -1,   344,    16,   106,    66,   106,
      -1,   351,    -1,    23,    -1,    -1,    26,   356,    28,    29,
      30,    31,    32,    33,    34,    -1,    -1,    37,    38,    39,
      40,    41,    -1,    -1,    -1,    -1,    46,    -1,    48,    -1,
      50,    -1,    -1,    -1,    54,    55,   179,   180,   181,   182,
     183,   184,   185,   186,    64,    65,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    16,    -1,    -1,    88,    -1,
      -1,    -1,    23,    -1,    -1,    26,    -1,    28,    29,    30,
      31,    32,    33,    34,    58,    59,    60,    61,    62,    63,
      37,    38,    39,    40,    41,    46,    -1,    48,    -1,    50,
      47,    48,    -1,    54,    55,    -1,    -1,    54,    55,    -1,
      -1,    -1,    -1,    64,    65,    66,    -1,    -1,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    16,    -1,    -1,    88,    -1,    -1,
      -1,    23,    -1,    -1,    26,    -1,    28,    29,    30,    31,
      32,    33,    34,    -1,    -1,    -1,    -1,    -1,    37,    38,
      39,    40,    41,    -1,    46,    -1,    48,    49,    50,    48,
      -1,    -1,    54,    55,    -1,    54,    55,    -1,    -1,    -1,
      -1,    -1,    64,    65,    -1,    -1,    -1,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    16,    -1,    -1,    88,    -1,    -1,    -1,
      23,    -1,    -1,    26,    -1,    28,    29,    30,    31,    32,
      33,    34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    46,    -1,    48,    -1,    50,    -1,    -1,
      -1,    54,    55,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    16,    -1,    -1,    88,    -1,    -1,    -1,    23,
      -1,    -1,    26,    -1,    28,    29,    30,    31,    32,    33,
      34,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    -1,    48,    -1,    50,    64,    65,    -1,
      54,    55,    -1,    -1,    71,    72,    -1,    74,    75,    -1,
      77,    78,    -1,    -1,    -1,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    48,    49,    50,    -1,    -1,    -1,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    84,    48,    49,
      50,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    48,    82,    50,    84,    -1,    -1,    54,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    -1,    82,    -1,    84,    37,    38,
      39,    40,    41,    -1,    -1,    -1,    -1,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    54,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    66
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    15,    90,    93,    94,    80,     0,    35,    91,    95,
       3,     7,     8,     9,    43,    44,    92,    96,   107,   108,
     110,   111,   112,    14,    10,    11,    37,    38,    39,    40,
      41,    48,    54,    55,    66,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   162,    66,    80,    82,   109,
     161,   162,   181,    52,   145,   113,   113,   113,    85,    97,
      97,    48,    48,    48,    48,    48,    16,    23,    26,    28,
      29,    30,    31,    32,    33,    34,    46,    48,    50,    64,
      65,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    81,    83,    84,    88,   101,   142,   143,   162,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,    85,
     163,   163,   113,    47,    99,    42,   113,    47,   113,   161,
      48,    50,   146,   147,   155,   156,   157,   160,   162,   164,
     113,     4,     5,    52,   117,   127,   117,   118,   118,    80,
     113,   113,    66,   165,   165,   165,   165,   165,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    49,
     165,    51,   172,   172,   172,    49,    49,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,   179,   180,    66,
      67,   144,   165,   117,    99,   163,   118,   161,   118,   155,
     158,   159,   160,    27,   148,   154,   161,    53,    86,   148,
     150,   148,   117,    18,   114,   115,   116,   181,   127,   128,
     133,   147,   117,   117,    49,    49,    49,    49,    49,    49,
     162,   165,   165,   165,   165,   165,   165,   165,   165,   165,
     144,    49,   167,   168,   169,   169,   169,   169,   169,   169,
     169,   169,   170,   170,    47,    49,    36,   119,   120,   119,
     119,    49,   159,    51,   151,   153,   159,   146,   119,   116,
       6,    17,    19,    45,   127,   129,   130,   131,   134,   135,
     136,   137,   139,   140,    86,   119,   119,    49,    47,    47,
      49,    49,    49,    49,    49,    49,    47,    49,   165,    22,
      21,   122,    87,   149,    47,   152,   127,   161,    48,   141,
     142,   173,   174,    48,    13,    53,   130,    86,   132,   128,
     165,   165,   165,    24,    25,   123,   124,   142,   162,   173,
     174,    22,    12,    20,   121,   125,   126,   150,   151,   127,
     162,   127,   138,   128,    47,    49,    49,    49,   173,   173,
     124,   123,    73,    73,   126,   125,    68,    13,   165,   165,
     127,    49,    49
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (void *YYPARSE_PARAM, const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (YYPARSE_PARAM, yymsg, yytype, yyvaluep)
    void *YYPARSE_PARAM;
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {
      case 69: /* "\"string literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 70: /* "\"double literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 71: /* "\"double positive literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 72: /* "\"double negative literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 73: /* "\"integer literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 74: /* "\"integer positive literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 75: /* "\"integer negative literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 76: /* "\"decimal literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 77: /* "\"decimal positive literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 78: /* "\"decimal negative literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 79: /* "\"boolean literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 80: /* "\"URI literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->uri))
#ifdef RAPTOR_V2_AVAILABLE
    raptor_free_uri_v2(((rasqal_query*)rq)->world->raptor_world_ptr, (yyvaluep->uri));
#else
    raptor_free_uri((yyvaluep->uri));
#endif
};

/* Line 1000 of yacc.c  */

	break;
      case 81: /* "\"URI literal (\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->uri))
#ifdef RAPTOR_V2_AVAILABLE
    raptor_free_uri_v2(((rasqal_query*)rq)->world->raptor_world_ptr, (yyvaluep->uri));
#else
    raptor_free_uri((yyvaluep->uri));
#endif
};

/* Line 1000 of yacc.c  */

	break;
      case 82: /* "\"QName literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */

	break;
      case 83: /* "\"QName literal (\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */

	break;
      case 84: /* "\"blank node literal\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */

	break;
      case 85: /* "\"identifier\"" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->name))
    RASQAL_FREE(cstring, (yyvaluep->name));
};

/* Line 1000 of yacc.c  */

	break;
      case 96: /* "SelectQuery" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 97: /* "SelectExpressionList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 98: /* "SelectExpressionListTail" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 99: /* "SelectTerm" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */

	break;
      case 100: /* "SelectExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 101: /* "AggregateExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 102: /* "CountAggregateExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 103: /* "SumAggregateExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 104: /* "AvgAggregateExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 105: /* "MinAggregateExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 106: /* "MaxAggregateExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 107: /* "ConstructQuery" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 108: /* "DescribeQuery" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 109: /* "VarOrIRIrefList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 116: /* "SourceSelector" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 123: /* "OrderConditionList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 124: /* "OrderCondition" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 127: /* "GroupGraphPattern" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 128: /* "TriplesBlockOpt" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 129: /* "GraphPatternListOpt" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 130: /* "GraphPatternList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 131: /* "GraphPatternListFilter" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 133: /* "TriplesBlock" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 134: /* "GraphPatternNotTriples" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 135: /* "OptionalGraphPattern" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 136: /* "GraphGraphPattern" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 137: /* "GroupOrUnionGraphPattern" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 138: /* "GroupOrUnionGraphPatternList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 139: /* "LetGraphPattern" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->graph_pattern))
    rasqal_free_graph_pattern((yyvaluep->graph_pattern));
};

/* Line 1000 of yacc.c  */

	break;
      case 140: /* "Filter" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 141: /* "Constraint" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 142: /* "FunctionCall" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 144: /* "ArgList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 145: /* "ConstructTemplate" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 146: /* "ConstructTriplesOpt" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 147: /* "TriplesSameSubject" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 148: /* "PropertyListNotEmpty" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 149: /* "PropertyListTailOpt" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 150: /* "PropertyList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 151: /* "ObjectList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 152: /* "ObjectTail" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 153: /* "Object" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 154: /* "Verb" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 155: /* "TriplesNode" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 156: /* "BlankNodePropertyList" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 157: /* "Collection" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 158: /* "GraphNodeListNotEmpty" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->seq))
    raptor_free_sequence((yyvaluep->seq));
};

/* Line 1000 of yacc.c  */

	break;
      case 159: /* "GraphNode" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 160: /* "VarOrTerm" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->formula))
    rasqal_free_formula((yyvaluep->formula));
};

/* Line 1000 of yacc.c  */

	break;
      case 161: /* "VarOrIRIref" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 162: /* "Var" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */

	break;
      case 163: /* "VarName" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->variable))
    rasqal_free_variable((yyvaluep->variable));
};

/* Line 1000 of yacc.c  */

	break;
      case 164: /* "GraphTerm" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 165: /* "Expression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 166: /* "ConditionalOrExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 167: /* "ConditionalAndExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 168: /* "RelationalExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 169: /* "AdditiveExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 170: /* "MultiplicativeExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 171: /* "UnaryExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 172: /* "PrimaryExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 173: /* "BrackettedExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 174: /* "BuiltInCall" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 175: /* "RegexExpression" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->expr))
    rasqal_free_expression((yyvaluep->expr));
};

/* Line 1000 of yacc.c  */

	break;
      case 176: /* "IRIrefBrace" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 177: /* "NumericLiteral" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 178: /* "NumericLiteralUnsigned" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 179: /* "NumericLiteralPositive" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 180: /* "NumericLiteralNegative" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 181: /* "IRIref" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;
      case 182: /* "BlankNode" */

/* Line 1000 of yacc.c  */

	{
  if((yyvaluep->literal))
    rasqal_free_literal((yyvaluep->literal));
};

/* Line 1000 of yacc.c  */

	break;

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */

    {
}
    break;

  case 3:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(sparql->extended)
    ((rasqal_query*)rq)->explain=1;
  else
    sparql_syntax_error((rasqal_query*)rq, "EXPLAIN cannot be used with SPARQL");
}
    break;

  case 4:

/* Line 1455 of yacc.c  */

    {
  /* nothing to do */
}
    break;

  case 5:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->selects=(yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb=RASQAL_QUERY_VERB_SELECT;
}
    break;

  case 6:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->constructs=(yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb=RASQAL_QUERY_VERB_CONSTRUCT;
}
    break;

  case 7:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->describes=(yyvsp[(1) - (1)].seq);
  ((rasqal_query*)rq)->verb=RASQAL_QUERY_VERB_DESCRIBE;
}
    break;

  case 8:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->verb=RASQAL_QUERY_VERB_ASK;
}
    break;

  case 9:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->verb=RASQAL_QUERY_VERB_DELETE;
}
    break;

  case 10:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->verb=RASQAL_QUERY_VERB_INSERT;
}
    break;

  case 11:

/* Line 1455 of yacc.c  */

    {
  /* nothing to do */
}
    break;

  case 12:

/* Line 1455 of yacc.c  */

    {
  rasqal_query_set_base_uri((rasqal_query*)rq, (yyvsp[(2) - (2)].uri));
}
    break;

  case 13:

/* Line 1455 of yacc.c  */

    {
  /* nothing to do */
}
    break;

  case 14:

/* Line 1455 of yacc.c  */

    {
  raptor_sequence *seq=((rasqal_query*)rq)->prefixes;
  unsigned const char* prefix_string=(yyvsp[(3) - (4)].name);
  size_t l=0;

  if(prefix_string)
    l=strlen((const char*)prefix_string);
  
  if(raptor_namespaces_find_namespace(((rasqal_query*)rq)->namespaces, prefix_string, l)) {
    /* A prefix may be defined only once */
    sparql_syntax_warning(((rasqal_query*)rq), 
                          "PREFIX %s can be defined only once.",
                          prefix_string ? (const char*)prefix_string : ":");
    RASQAL_FREE(cstring, prefix_string);
#ifdef RAPTOR_V2_AVAILABLE
    raptor_free_uri_v2(((rasqal_query*)rq)->world->raptor_world_ptr, (yyvsp[(4) - (4)].uri));
#else
    raptor_free_uri((yyvsp[(4) - (4)].uri));
#endif
  } else {
    rasqal_prefix *p=rasqal_new_prefix(((rasqal_query*)rq)->world, prefix_string, (yyvsp[(4) - (4)].uri));
    if(!p)
      YYERROR_MSG("PrefixDeclOpt: failed to create new prefix");
    if(raptor_sequence_push(seq, p))
      YYERROR_MSG("PrefixDeclOpt: cannot push prefix to seq");
    if(rasqal_query_declare_prefix(((rasqal_query*)rq), p)) {
      YYERROR_MSG("PrefixDeclOpt: cannot declare prefix");
    }
  }
}
    break;

  case 15:

/* Line 1455 of yacc.c  */

    {
  /* nothing to do, rq->prefixes already initialised */
}
    break;

  case 16:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(3) - (6)].seq);
  ((rasqal_query*)rq)->distinct=1;
}
    break;

  case 17:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(3) - (6)].seq);
  ((rasqal_query*)rq)->distinct=2;
}
    break;

  case 18:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(2) - (5)].seq);
}
    break;

  case 19:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (1)].seq);
}
    break;

  case 20:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=NULL;
  ((rasqal_query*)rq)->wildcard=1;
}
    break;

  case 21:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
    YYERROR_MSG("SelectExpressionListTail 1: sequence push failed");
  }
}
    break;

  case 22:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
    YYERROR_MSG("SelectExpressionListTail 2: sequence push failed");
  }
}
    break;

  case 23:

/* Line 1455 of yacc.c  */

    {
  /* The variables are freed from the raptor_query field variables */
  (yyval.seq)=raptor_new_sequence(NULL, (raptor_sequence_print_handler*)rasqal_variable_print);
  if(!(yyval.seq))
    YYERROR_MSG("SelectExpressionListTail 3: failed to create sequence");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].variable))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
    YYERROR_MSG("SelectExpressionListTail 3: sequence push failed");
  }
}
    break;

  case 24:

/* Line 1455 of yacc.c  */

    {
  (yyval.variable)=(yyvsp[(1) - (1)].variable);
}
    break;

  case 25:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  (yyval.variable)=NULL;
  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, "SELECT expression AS Variable cannot be used with SPARQL");
  else {
    if(rasqal_expression_mentions_variable((yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].variable))) {
      sparql_query_error_full((rasqal_query*)rq, "SELECT expression contains the AS variable name '%s'", (yyvsp[(3) - (3)].variable)->name);
    } else {
      (yyval.variable)=(yyvsp[(3) - (3)].variable);
      (yyvsp[(3) - (3)].variable)->expression=(yyvsp[(1) - (3)].expr);
    }

  }
}
    break;

  case 26:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 27:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(2) - (3)].expr);
}
    break;

  case 28:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(2) - (3)].expr);
}
    break;

  case 29:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 30:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 31:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 32:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 33:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr) = (yyvsp[(1) - (1)].expr);
}
    break;

  case 34:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq, "COUNT cannot be used with SPARQL");
    (yyval.expr)=NULL;
  } else {
    (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_COUNT, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("CountAggregateExpression 1: cannot create expr");
  }
}
    break;

  case 35:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq, "COUNT cannot be used with SPARQL");
    (yyval.expr)=NULL;
  } else {
    rasqal_expression* vs=rasqal_new_0op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_VARSTAR);
    if(!vs)
      YYERROR_MSG("CountAggregateExpression 2: cannot create varstar expr");
    (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_COUNT, vs);
    if(!(yyval.expr))
      YYERROR_MSG("CountAggregateExpression 2: cannot create expr");
  }
}
    break;

  case 36:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq, "SUM cannot be used with SPARQL");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_SUM, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("SumAggregateExpression 1: cannot create expr");
  }
}
    break;

  case 37:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq, "AVG cannot be used with SPARQL");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_AVG, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("AvgAggregateExpression 1: cannot create expr");
  }
}
    break;

  case 38:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq, "MIN cannot be used with SPARQL");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_MIN, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("MinAggregateExpression 1: cannot create expr");
  }
}
    break;

  case 39:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended) {
    sparql_syntax_error((rasqal_query*)rq, "MAX cannot be used with SPARQL");
    (yyval.expr) = NULL;
  } else {
    (yyval.expr) = rasqal_new_1op_expression(((rasqal_query*)rq)->world,
                                   RASQAL_EXPR_MAX, (yyvsp[(3) - (4)].expr));
    if(!(yyval.expr))
      YYERROR_MSG("MaxAggregateExpression 1: cannot create expr");
  }
}
    break;

  case 40:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(2) - (5)].seq);
}
    break;

  case 41:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(2) - (5)].seq);
}
    break;

  case 42:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=NULL;
}
    break;

  case 43:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (2)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
    YYERROR_MSG("VarOrIRIrefList 1: sequence push failed");
  }
}
    break;

  case 44:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (3)].seq);
  if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
    YYERROR_MSG("VarOrIRIrefList 2: sequence push failed");
  }
}
    break;

  case 45:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_literal, (raptor_sequence_print_handler*)rasqal_literal_print);
  if(!(yyval.seq))
    YYERROR_MSG("VarOrIRIrefList 3: cannot create seq");
  if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].literal))) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
    YYERROR_MSG("VarOrIRIrefList 3: sequence push failed");
  }
}
    break;

  case 46:

/* Line 1455 of yacc.c  */

    {
  /* nothing to do */
}
    break;

  case 47:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, "DELETE cannot be used with SPARQL");
}
    break;

  case 48:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, "INSERT cannot be used with SPARQL");
}
    break;

  case 52:

/* Line 1455 of yacc.c  */

    {
  if((yyvsp[(1) - (1)].literal)) {
    raptor_uri* uri=rasqal_literal_as_uri((yyvsp[(1) - (1)].literal));
    if(rasqal_query_add_data_graph((rasqal_query*)rq, uri, NULL,
                                   RASQAL_DATA_GRAPH_BACKGROUND)) {
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
      YYERROR_MSG("DefaultGraphClause: rasqal_query_add_data_graph failed");
    }
    rasqal_free_literal((yyvsp[(1) - (1)].literal));
  }
}
    break;

  case 53:

/* Line 1455 of yacc.c  */

    {
  if((yyvsp[(2) - (2)].literal)) {
    raptor_uri* uri=rasqal_literal_as_uri((yyvsp[(2) - (2)].literal));
    if(rasqal_query_add_data_graph((rasqal_query*)rq, uri, uri,
                                   RASQAL_DATA_GRAPH_NAMED)) {
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
      YYERROR_MSG("NamedGraphClause: rasqal_query_add_data_graph failed");
    }
    rasqal_free_literal((yyvsp[(2) - (2)].literal));
  }
}
    break;

  case 54:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 55:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->query_graph_pattern=(yyvsp[(2) - (2)].graph_pattern);
}
    break;

  case 56:

/* Line 1455 of yacc.c  */

    {
  ((rasqal_query*)rq)->query_graph_pattern=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 60:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, "GROUP BY cannot be used with SPARQL");
  else if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "GROUP BY cannot be used with ASK");
  } else {
    raptor_sequence *seq=(yyvsp[(3) - (3)].seq);
    ((rasqal_query*)rq)->group_conditions_sequence=seq;
    if(seq) {
      int i;
      
      for(i=0; i < raptor_sequence_size(seq); i++) {
        rasqal_expression* e=(rasqal_expression*)raptor_sequence_get_at(seq, i);
        if(e->op == RASQAL_EXPR_ORDER_COND_ASC)
          e->op = RASQAL_EXPR_GROUP_COND_ASC;
        else
          e->op = RASQAL_EXPR_GROUP_COND_DESC;
      }
    }
  }
}
    break;

  case 66:

/* Line 1455 of yacc.c  */

    { 
}
    break;

  case 67:

/* Line 1455 of yacc.c  */

    {
  if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "ORDER BY cannot be used with ASK");
  } else {
    ((rasqal_query*)rq)->order_conditions_sequence=(yyvsp[(3) - (3)].seq);
  }
}
    break;

  case 69:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (2)].seq);
  if((yyvsp[(2) - (2)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq)=NULL;
      YYERROR_MSG("OrderConditionList 1: sequence push failed");
    }
}
    break;

  case 70:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression, (raptor_sequence_print_handler*)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("OrderConditionList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq)=NULL;
      YYERROR_MSG("OrderConditionList 2: sequence push failed");
    }
}
    break;

  case 71:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 72:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ORDER_COND_DESC, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 2: cannot create expr");
}
    break;

  case 73:

/* Line 1455 of yacc.c  */

    {
  /* The direction of ordering is ascending by default */
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 3: cannot create expr");
}
    break;

  case 74:

/* Line 1455 of yacc.c  */

    {
  rasqal_literal* l;
  rasqal_expression *e;
  l=rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("OrderCondition 4: cannot create lit");
  e=rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("OrderCondition 4: cannot create lit expr");

  /* The direction of ordering is ascending by default */
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ORDER_COND_ASC, e);
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 1: cannot create expr");
}
    break;

  case 75:

/* Line 1455 of yacc.c  */

    {
  /* The direction of ordering is ascending by default */
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 5: cannot create expr");
}
    break;

  case 76:

/* Line 1455 of yacc.c  */

    {
  /* The direction of ordering is ascending by default */
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ORDER_COND_ASC, (yyvsp[(1) - (1)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("OrderCondition 6: cannot create expr");
}
    break;

  case 77:

/* Line 1455 of yacc.c  */

    {
  if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "LIMIT cannot be used with ASK");
  } else {
    if((yyvsp[(2) - (2)].literal) != NULL) {
      ((rasqal_query*)rq)->limit=(yyvsp[(2) - (2)].literal)->value.integer;
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
    }
  }
  
}
    break;

  case 78:

/* Line 1455 of yacc.c  */

    {
  if(((rasqal_query*)rq)->verb == RASQAL_QUERY_VERB_ASK) {
    sparql_query_error((rasqal_query*)rq, "LIMIT cannot be used with ASK");
  } else {
    if((yyvsp[(2) - (2)].literal) != NULL) {
      ((rasqal_query*)rq)->offset=(yyvsp[(2) - (2)].literal)->value.integer;
      rasqal_free_literal((yyvsp[(2) - (2)].literal));
    }
  }
}
    break;

  case 79:

/* Line 1455 of yacc.c  */

    {
  rasqal_graph_pattern *formula_gp=NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GroupGraphPattern\n  TriplesBlockOpt=");
  if((yyvsp[(2) - (4)].formula))
    rasqal_formula_print((yyvsp[(2) - (4)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphpatternListOpt=");
  if((yyvsp[(3) - (4)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (4)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  if(!(yyvsp[(2) - (4)].formula) && !(yyvsp[(3) - (4)].graph_pattern)) {
    (yyval.graph_pattern)=rasqal_new_2_group_graph_pattern((rasqal_query*)rq, NULL, NULL);
    if(!(yyval.graph_pattern))
      YYERROR_MSG("GroupGraphPattern: cannot create group gp");
  } else {
    if((yyvsp[(2) - (4)].formula)) {
      formula_gp=rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq, (yyvsp[(2) - (4)].formula));
      if(!formula_gp) {
        if((yyvsp[(3) - (4)].graph_pattern))
          rasqal_free_graph_pattern((yyvsp[(3) - (4)].graph_pattern));
        YYERROR_MSG("GroupGraphPattern: cannot create formula_gp");
      }
    }

    if((yyvsp[(3) - (4)].graph_pattern)) {
      (yyval.graph_pattern)=(yyvsp[(3) - (4)].graph_pattern);
      if(formula_gp && raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, formula_gp)) {
        rasqal_free_graph_pattern((yyval.graph_pattern));
        (yyval.graph_pattern)=NULL;
        YYERROR_MSG("GroupGraphPattern: sequence push failed");
      }
    } else
      (yyval.graph_pattern)=formula_gp;
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 80:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlockOpt 1\n  TriplesBlock=");
  if((yyvsp[(1) - (1)].formula))
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 81:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=NULL;
}
    break;

  case 82:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListOpt\n  GraphPatternListOpt=");
  if((yyvsp[(1) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", GraphPatternList=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern)= ((yyvsp[(1) - (2)].graph_pattern) ? (yyvsp[(1) - (2)].graph_pattern) : (yyvsp[(2) - (2)].graph_pattern));
  if((yyvsp[(1) - (2)].graph_pattern) && (yyvsp[(2) - (2)].graph_pattern)) {
    (yyval.graph_pattern)=(yyvsp[(1) - (2)].graph_pattern);
    if(rasqal_graph_patterns_join((yyval.graph_pattern), (yyvsp[(2) - (2)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      (yyval.graph_pattern)=NULL;
      YYERROR_MSG("ConstructTriplesOpt: sequence join failed");
    }
    rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
  }
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after grouping graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 83:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 84:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=NULL;
}
    break;

  case 85:

/* Line 1455 of yacc.c  */

    {
  rasqal_graph_pattern *formula_gp=NULL;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternList\n  GraphPatternListFilter=");
  if((yyvsp[(1) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].formula)) {
    formula_gp=rasqal_new_basic_graph_pattern_from_formula((rasqal_query*)rq, (yyvsp[(3) - (3)].formula));
    if(!formula_gp) {
      if((yyvsp[(1) - (3)].graph_pattern))
        rasqal_free_graph_pattern((yyvsp[(1) - (3)].graph_pattern));
      YYERROR_MSG("GraphPatternList: cannot create formula_gp");
    }
  }
  (yyval.graph_pattern)=rasqal_new_2_group_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (3)].graph_pattern), formula_gp);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternList: cannot create sequence");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 86:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 1\n  GraphPatternNotTriples=");
  if((yyvsp[(1) - (1)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(1) - (1)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 87:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphPatternListFilter 2\n  Filter=");
  if((yyvsp[(1) - (1)].expr))
    rasqal_expression_print((yyvsp[(1) - (1)].expr), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif

  (yyval.graph_pattern)=rasqal_new_filter_graph_pattern((rasqal_query*)rq, (yyvsp[(1) - (1)].expr));
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GraphPatternListFilter 2: cannot create graph pattern");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after graph pattern=");
  if((yyval.graph_pattern))
    rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 90:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesBlock\n  TriplesSameSubject=");
  if((yyvsp[(1) - (3)].formula))
    rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, ", TriplesBlockOpt=");
  if((yyvsp[(3) - (3)].formula))
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n", DEBUG_FH);
#endif


  (yyval.formula)= ((yyvsp[(1) - (3)].formula) ? (yyvsp[(1) - (3)].formula) : (yyvsp[(3) - (3)].formula));
  if((yyvsp[(1) - (3)].formula) && (yyvsp[(3) - (3)].formula)) {
    /* $1 and $3 are freed as necessary */
    (yyval.formula)=rasqal_formula_join((yyvsp[(1) - (3)].formula), (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(1) - (3)].formula))
      YYERROR_MSG("TriplesBlock: formula join failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 91:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 92:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 93:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 94:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 95:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 96:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PatternElementForms 4\n  graphpattern=");
  if((yyvsp[(2) - (2)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(2) - (2)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  (yyval.graph_pattern)=NULL;

  if((yyvsp[(2) - (2)].graph_pattern)) {
    raptor_sequence *seq;

    seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern, (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(2) - (2)].graph_pattern));
      YYERROR_MSG("OptionalGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(2) - (2)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("OptionalGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern)=rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                  seq,
                                                  RASQAL_GRAPH_PATTERN_OPERATOR_OPTIONAL);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("OptionalGraphPattern: cannot create graph pattern");
      }
    }
  }
}
    break;

  case 97:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern 2\n  varoruri=");
  rasqal_literal_print((yyvsp[(2) - (3)].literal), DEBUG_FH);
  fprintf(DEBUG_FH, ", graphpattern=");
  if((yyvsp[(3) - (3)].graph_pattern))
    rasqal_graph_pattern_print((yyvsp[(3) - (3)].graph_pattern), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  if((yyvsp[(3) - (3)].graph_pattern)) {
    raptor_sequence *seq;

    seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern, (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
    if(!seq) {
      rasqal_free_graph_pattern((yyvsp[(3) - (3)].graph_pattern));
      YYERROR_MSG("GraphGraphPattern 1: cannot create sequence");
    } else {
      if(raptor_sequence_push(seq, (yyvsp[(3) - (3)].graph_pattern))) {
        raptor_free_sequence(seq);
        YYERROR_MSG("GraphGraphPattern 2: sequence push failed");
      } else {
        (yyval.graph_pattern) = rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                                    seq,
                                                    RASQAL_GRAPH_PATTERN_OPERATOR_GRAPH);
        if(!(yyval.graph_pattern))
          YYERROR_MSG("GraphGraphPattern: cannot create graph pattern");
        else
          rasqal_graph_pattern_set_origin((yyval.graph_pattern), (yyvsp[(2) - (3)].literal));
      }
    }
  }


#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif

  rasqal_free_literal((yyvsp[(2) - (3)].literal));
}
    break;

  case 98:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(3) - (3)].graph_pattern);
  if(raptor_sequence_shift((yyval.graph_pattern)->graph_patterns, (yyvsp[(1) - (3)].graph_pattern))) {
    rasqal_free_graph_pattern((yyval.graph_pattern));
    (yyval.graph_pattern)=NULL;
    YYERROR_MSG("GroupOrUnionGraphPattern: sequence push failed");
  }

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "UnionGraphPattern\n  graphpattern=");
  rasqal_graph_pattern_print((yyval.graph_pattern), DEBUG_FH);
  fputs("\n\n", DEBUG_FH);
#endif
}
    break;

  case 99:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (1)].graph_pattern);
}
    break;

  case 100:

/* Line 1455 of yacc.c  */

    {
  (yyval.graph_pattern)=(yyvsp[(1) - (3)].graph_pattern);
  if((yyvsp[(3) - (3)].graph_pattern))
    if(raptor_sequence_push((yyval.graph_pattern)->graph_patterns, (yyvsp[(3) - (3)].graph_pattern))) {
      rasqal_free_graph_pattern((yyval.graph_pattern));
      (yyval.graph_pattern)=NULL;
      YYERROR_MSG("GroupOrUnionGraphPatternList 1: sequence push failed");
    }
}
    break;

  case 101:

/* Line 1455 of yacc.c  */

    {
  raptor_sequence *seq;
  seq=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_graph_pattern, (raptor_sequence_print_handler*)rasqal_graph_pattern_print);
  if(!seq) {
    if((yyvsp[(1) - (1)].graph_pattern))
      rasqal_free_graph_pattern((yyvsp[(1) - (1)].graph_pattern));
    YYERROR_MSG("GroupOrUnionGraphPatternList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].graph_pattern))
    if(raptor_sequence_push(seq, (yyvsp[(1) - (1)].graph_pattern))) {
      raptor_free_sequence(seq);
      YYERROR_MSG("GroupOrUnionGraphPatternList 2: sequence push failed");
    }
  (yyval.graph_pattern)=rasqal_new_graph_pattern_from_sequence((rasqal_query*)rq,
                                            seq,
                                            RASQAL_GRAPH_PATTERN_OPERATOR_UNION);
  if(!(yyval.graph_pattern))
    YYERROR_MSG("GroupOrUnionGraphPatternList 1: cannot create gp");
}
    break;

  case 102:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if((yyvsp[(3) - (6)].variable) && (yyvsp[(5) - (6)].expr)) {
    if(sparql->extended)
      (yyval.graph_pattern) = rasqal_new_let_graph_pattern((rasqal_query*)rq, (yyvsp[(3) - (6)].variable), (yyvsp[(5) - (6)].expr));
    else {
      sparql_syntax_error((rasqal_query*)rq, "LET cannot be used with SPARQL");
      rasqal_free_expression((yyvsp[(5) - (6)].expr));
      (yyval.graph_pattern) = NULL;
    }
  } else
    (yyval.graph_pattern) = NULL;
}
    break;

  case 103:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(2) - (2)].expr);
}
    break;

  case 104:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 105:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 106:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 107:

/* Line 1455 of yacc.c  */

    {
  raptor_uri* uri=rasqal_literal_as_uri((yyvsp[(1) - (3)].literal));
  
  if(!(yyvsp[(2) - (3)].seq)) {
    (yyvsp[(2) - (3)].seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression, (raptor_sequence_print_handler*)rasqal_expression_print);
    if(!(yyvsp[(2) - (3)].seq)) {
      rasqal_free_literal((yyvsp[(1) - (3)].literal));
      YYERROR_MSG("FunctionCall: cannot create sequence");
    }
  }

#ifdef RAPTOR_V2_AVAILABLE
  uri = raptor_uri_copy_v2(((rasqal_query*)rq)->world->raptor_world_ptr, uri);
#else
  uri = raptor_uri_copy(uri);
#endif

  if(raptor_sequence_size((yyvsp[(2) - (3)].seq)) == 1 &&
     rasqal_xsd_is_datatype_uri(((rasqal_query*)rq)->world, uri)) {
    rasqal_expression* e=(rasqal_expression*)raptor_sequence_pop((yyvsp[(2) - (3)].seq));
    (yyval.expr)=rasqal_new_cast_expression(((rasqal_query*)rq)->world, uri, e);
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  } else {
    (yyval.expr)=rasqal_new_function_expression(((rasqal_query*)rq)->world, uri, (yyvsp[(2) - (3)].seq));
  }
  rasqal_free_literal((yyvsp[(1) - (3)].literal));

  if(!(yyval.expr))
    YYERROR_MSG("FunctionCall: cannot create expr");
}
    break;

  case 108:

/* Line 1455 of yacc.c  */

    {
  rasqal_sparql_query_language* sparql;
  sparql = (rasqal_sparql_query_language*)(((rasqal_query*)rq)->context);

  if(!sparql->extended)
    sparql_syntax_error((rasqal_query*)rq, "COALESCE cannot be used with SPARQL");

  if(!(yyvsp[(3) - (4)].seq)) {
    (yyvsp[(3) - (4)].seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression, (raptor_sequence_print_handler*)rasqal_expression_print);
    if(!(yyvsp[(3) - (4)].seq))
      YYERROR_MSG("FunctionCall: cannot create sequence");
  }

  (yyval.expr) = rasqal_new_coalesce_expression(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].seq));
  if(!(yyval.expr))
    YYERROR_MSG("Coalesce: cannot create expr");
}
    break;

  case 109:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(1) - (3)].seq);
  if((yyvsp[(3) - (3)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(3) - (3)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq)=NULL;
      YYERROR_MSG("ArgList 1: sequence push failed");
    }
}
    break;

  case 110:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_expression, (raptor_sequence_print_handler*)rasqal_expression_print);
  if(!(yyval.seq)) {
    if((yyvsp[(1) - (1)].expr))
      rasqal_free_expression((yyvsp[(1) - (1)].expr));
    YYERROR_MSG("ArgList 2: cannot create sequence");
  }
  if((yyvsp[(1) - (1)].expr))
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].expr))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq)=NULL;
      YYERROR_MSG("ArgList 2: sequence push failed");
    }
}
    break;

  case 111:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=NULL;
}
    break;

  case 112:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=(yyvsp[(2) - (3)].seq);
}
    break;

  case 113:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=NULL;
 
  if((yyvsp[(1) - (3)].formula)) {
    (yyval.seq)=(yyvsp[(1) - (3)].formula)->triples;
    (yyvsp[(1) - (3)].formula)->triples=NULL;
    rasqal_free_formula((yyvsp[(1) - (3)].formula));
  }
  
  if((yyvsp[(3) - (3)].seq)) {
    if(!(yyval.seq)) {
      (yyval.seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
      if(!(yyval.seq)) {
        raptor_free_sequence((yyvsp[(3) - (3)].seq));
        YYERROR_MSG("ConstructTriplesOpt: cannot create sequence");
      }
    }

    if(raptor_sequence_join((yyval.seq), (yyvsp[(3) - (3)].seq))) {
      raptor_free_sequence((yyvsp[(3) - (3)].seq));
      raptor_free_sequence((yyval.seq));
      (yyval.seq)=NULL;
      YYERROR_MSG("ConstructTriplesOpt: sequence join failed");
    }
    raptor_free_sequence((yyvsp[(3) - (3)].seq));
  }

 }
    break;

  case 114:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=NULL;
  
  if((yyvsp[(1) - (1)].formula)) {
    (yyval.seq)=(yyvsp[(1) - (1)].formula)->triples;
    (yyvsp[(1) - (1)].formula)->triples=NULL;
    rasqal_free_formula((yyvsp[(1) - (1)].formula));
  }
  
}
    break;

  case 115:

/* Line 1455 of yacc.c  */

    {
  (yyval.seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
  if(!(yyval.seq)) {
    YYERROR_MSG("ConstructTriplesOpt: cannot create sequence");
  }
}
    break;

  case 116:

/* Line 1455 of yacc.c  */

    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 1\n  subject=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq=(yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject=(yyvsp[(1) - (2)].formula)->value;
    
    /* non-empty property list, handle it  */
    for(i=0; i < raptor_sequence_size(seq); i++) {
      rasqal_triple* t2=(rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject=rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula)=rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 1: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 117:

/* Line 1455 of yacc.c  */

    {
  int i;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "TriplesSameSubject 2\n  subject=");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "\n  propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else     
    fprintf(DEBUG_FH, "\n  and empty propertyList\n");
#endif

  if((yyvsp[(2) - (2)].formula)) {
    raptor_sequence *seq=(yyvsp[(2) - (2)].formula)->triples;
    rasqal_literal *subject=(yyvsp[(1) - (2)].formula)->value;
    
    /* non-empty property list, handle it  */
    for(i=0; i < raptor_sequence_size(seq); i++) {
      rasqal_triple* t2=(rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      t2->subject=rasqal_new_literal_from_literal(subject);
    }
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution propertyList=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  }

  (yyval.formula)=rasqal_formula_join((yyvsp[(1) - (2)].formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("TriplesSameSubject 2: formula join failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  after joining formula=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 118:

/* Line 1455 of yacc.c  */

    {
  int i;
  
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "PropertyList 1\n  Verb=");
  rasqal_formula_print((yyvsp[(1) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  ObjectList=");
  rasqal_formula_print((yyvsp[(2) - (3)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n  PropertyListTail=");
  if((yyvsp[(3) - (3)].formula) != NULL)
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif
  
  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, " empty ObjectList not processed\n");
#endif
  } else if((yyvsp[(1) - (3)].formula) && (yyvsp[(2) - (3)].formula)) {
    raptor_sequence *seq=(yyvsp[(2) - (3)].formula)->triples;
    rasqal_literal *predicate=(yyvsp[(1) - (3)].formula)->value;
    rasqal_formula *formula;
    rasqal_triple *t2;

    formula=rasqal_new_formula();
    if(!formula) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create formula");
    }
    formula->triples=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
    if(!formula->triples) {
      rasqal_free_formula(formula);
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      if((yyvsp[(3) - (3)].formula))
        rasqal_free_formula((yyvsp[(3) - (3)].formula));
      YYERROR_MSG("PropertyList 1: cannot create sequence");
    }

    /* non-empty property list, handle it  */
    for(i=0; i<raptor_sequence_size(seq); i++) {
      t2=(rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(!t2->predicate)
        t2->predicate=(rasqal_literal*)rasqal_new_literal_from_literal(predicate);
    }
  
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after substitution ObjectList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    while(raptor_sequence_size(seq)) {
      t2=(rasqal_triple*)raptor_sequence_unshift(seq);
      if(raptor_sequence_push(formula->triples, t2)) {
        rasqal_free_formula(formula);
        rasqal_free_formula((yyvsp[(1) - (3)].formula));
        rasqal_free_formula((yyvsp[(2) - (3)].formula));
        if((yyvsp[(3) - (3)].formula))
          rasqal_free_formula((yyvsp[(3) - (3)].formula));
        YYERROR_MSG("PropertyList 1: sequence push failed");
      }
    }

    (yyvsp[(3) - (3)].formula)=rasqal_formula_join(formula, (yyvsp[(3) - (3)].formula));
    if(!(yyvsp[(3) - (3)].formula)) {
      rasqal_free_formula((yyvsp[(1) - (3)].formula));
      rasqal_free_formula((yyvsp[(2) - (3)].formula));
      YYERROR_MSG("PropertyList 1: formula join failed");
    }

#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  after appending ObjectList=");
    rasqal_formula_print((yyvsp[(3) - (3)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif

    rasqal_free_formula((yyvsp[(2) - (3)].formula));
  }

  if((yyvsp[(1) - (3)].formula))
    rasqal_free_formula((yyvsp[(1) - (3)].formula));

  (yyval.formula)=(yyvsp[(3) - (3)].formula);
}
    break;

  case 119:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(2) - (2)].formula);
}
    break;

  case 120:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=NULL;
}
    break;

  case 121:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 122:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=NULL;
}
    break;

  case 123:

/* Line 1455 of yacc.c  */

    {
  rasqal_formula *formula;
  rasqal_triple *triple;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "ObjectList 1\n");
  fprintf(DEBUG_FH, "  Object=\n");
  rasqal_formula_print((yyvsp[(1) - (2)].formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  ObjectTail=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty ObjectTail\n");
#endif

  formula=rasqal_new_formula();
  if(!formula) {
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create formula");
  }
  
  formula->triples=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
  if(!formula->triples) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create sequence");
  }

  triple=rasqal_new_triple(NULL, NULL, (yyvsp[(1) - (2)].formula)->value);
  (yyvsp[(1) - (2)].formula)->value=NULL; /* value now owned by triple */
  if(!triple) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: cannot create triple");
  }

  if(raptor_sequence_push(formula->triples, triple)) {
    rasqal_free_formula(formula);
    rasqal_free_formula((yyvsp[(1) - (2)].formula));
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: sequence push failed");
  }

  (yyval.formula)=rasqal_formula_join(formula, (yyvsp[(1) - (2)].formula));
  if(!(yyval.formula)) {
    if((yyvsp[(2) - (2)].formula))
      rasqal_free_formula((yyvsp[(2) - (2)].formula));
    YYERROR_MSG("ObjectList: formula join $1 failed");
  }

  (yyval.formula)=rasqal_formula_join((yyval.formula), (yyvsp[(2) - (2)].formula));
  if(!(yyval.formula))
    YYERROR_MSG("ObjectList: formula join $2 failed");

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  objectList is now ");
  if((yyval.formula))
    raptor_sequence_print((yyval.formula)->triples, DEBUG_FH);
  else
    fputs("NULL", DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 124:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(2) - (2)].formula);
}
    break;

  case 125:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=NULL;
}
    break;

  case 126:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 127:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=rasqal_new_formula();
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("Verb 1: cannot create formula");
  }
  (yyval.formula)->value=(yyvsp[(1) - (1)].literal);
}
    break;

  case 128:

/* Line 1455 of yacc.c  */

    {
  raptor_uri *uri;

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "verb Verb=rdf:type (a)\n");
#endif

#ifdef RAPTOR_V2_AVAILABLE
  uri = raptor_new_uri_for_rdf_concept_v2(((rasqal_query*)rq)->world->raptor_world_ptr, "type");
#else
  uri = raptor_new_uri_for_rdf_concept("type");
#endif
  if(!uri)
    YYERROR_MSG("Verb 2: uri for rdf concept type failed");
  (yyval.formula)=rasqal_new_formula();
  if(!(yyval.formula)) {
#ifdef RAPTOR_V2_AVAILABLE
    raptor_free_uri_v2(((rasqal_query*)rq)->world->raptor_world_ptr, uri);
#else
    raptor_free_uri(uri);
#endif
    YYERROR_MSG("Verb 2: cannot create formula");
  }
  (yyval.formula)->value=rasqal_new_uri_literal(((rasqal_query*)rq)->world, uri);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula)=NULL;
    YYERROR_MSG("Verb 2: cannot create uri literal");
  }
}
    break;

  case 129:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 130:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 131:

/* Line 1455 of yacc.c  */

    {
  int i;
  const unsigned char *id;

  if((yyvsp[(2) - (3)].formula) == NULL) {
    (yyval.formula)=rasqal_new_formula();
    if(!(yyval.formula))
      YYERROR_MSG("BlankNodePropertyList: cannot create formula");
  } else {
    (yyval.formula)=(yyvsp[(2) - (3)].formula);
    if((yyval.formula)->value) {
      rasqal_free_literal((yyval.formula)->value);
      (yyval.formula)->value=NULL;
    }
  }
  
  id=rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula)=NULL;
    YYERROR_MSG("BlankNodeProperyList: cannot create bnodeid");
  }

  (yyval.formula)->value=rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, id);
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula)=NULL;
    YYERROR_MSG("BlankNodePropertyList: cannot create literal");
  }

  if((yyvsp[(2) - (3)].formula) == NULL) {
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif
  } else {
    raptor_sequence *seq=(yyvsp[(2) - (3)].formula)->triples;

    /* non-empty property list, handle it  */
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "TriplesNode\n  PropertyList=");
    raptor_sequence_print(seq, DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
#endif

    for(i=0; i<raptor_sequence_size(seq); i++) {
      rasqal_triple* t2=(rasqal_triple*)raptor_sequence_get_at(seq, i);
      if(t2->subject)
        continue;
      
      t2->subject=(rasqal_literal*)rasqal_new_literal_from_literal((yyval.formula)->value);
    }

#if RASQAL_DEBUG > 1
    fprintf(DEBUG_FH, "  after substitution formula=");
    rasqal_formula_print((yyval.formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }
}
    break;

  case 132:

/* Line 1455 of yacc.c  */

    {
  int i;
  rasqal_query* rdf_query=(rasqal_query*)rq;
  rasqal_literal* first_identifier=NULL;
  rasqal_literal* rest_identifier=NULL;
  rasqal_literal* object=NULL;
  rasqal_literal* blank=NULL;

#if RASQAL_DEBUG > 1
  char const *errmsg;
  #define YYERR_MSG_GOTO(label,msg) do { errmsg = msg; goto label; } while(0)
#else
  #define YYERR_MSG_GOTO(label,ignore) goto label
#endif

#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "Collection\n  GraphNodeListNotEmpty=");
  raptor_sequence_print((yyvsp[(2) - (3)].seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n");
#endif

  (yyval.formula)=rasqal_new_formula();
  if(!(yyval.formula))
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create formula");

  (yyval.formula)->triples=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_triple, (raptor_sequence_print_handler*)rasqal_triple_print);
  if(!(yyval.formula)->triples)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create sequence");

  first_identifier = rasqal_new_uri_literal(rdf_query->world,
#ifdef RAPTOR_V2_AVAILABLE
                                            raptor_uri_copy_v2(rdf_query->world->raptor_world_ptr, rdf_query->world->rdf_first_uri)
#else
                                            raptor_uri_copy(rdf_query->world->rdf_first_uri)
#endif
                                            );
  if(!first_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot first_identifier");
  
  rest_identifier = rasqal_new_uri_literal(rdf_query->world,
#ifdef RAPTOR_V2_AVAILABLE
                                           raptor_uri_copy_v2(rdf_query->world->raptor_world_ptr, rdf_query->world->rdf_rest_uri)
#else
                                           raptor_uri_copy(rdf_query->world->rdf_rest_uri)
#endif
                                           );
  if(!rest_identifier)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create rest_identifier");
  
  object = rasqal_new_uri_literal(rdf_query->world,
#ifdef RAPTOR_V2_AVAILABLE
                                  raptor_uri_copy_v2(rdf_query->world->raptor_world_ptr, rdf_query->world->rdf_nil_uri)
#else
                                  raptor_uri_copy(rdf_query->world->rdf_nil_uri)
#endif
                                  );
  if(!object)
    YYERR_MSG_GOTO(err_Collection, "Collection: cannot create nil object");

  for(i=raptor_sequence_size((yyvsp[(2) - (3)].seq))-1; i>=0; i--) {
    rasqal_formula* f=(rasqal_formula*)raptor_sequence_get_at((yyvsp[(2) - (3)].seq), i);
    rasqal_triple *t2;
    const unsigned char *blank_id=NULL;

    blank_id=rasqal_query_generate_bnodeid(rdf_query, NULL);
    if(!blank_id)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnodeid");

    blank=rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, blank_id);
    if(!blank)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create bnode");

    /* Move existing formula triples */
    if(f->triples)
      if(raptor_sequence_join((yyval.formula)->triples, f->triples))
        YYERR_MSG_GOTO(err_Collection, "Collection: sequence join failed");

    /* add new triples we needed */
    t2=rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                         rasqal_new_literal_from_literal(first_identifier),
                         rasqal_new_literal_from_literal(f->value));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple");

    t2=rasqal_new_triple(rasqal_new_literal_from_literal(blank),
                         rasqal_new_literal_from_literal(rest_identifier),
                         rasqal_new_literal_from_literal(object));
    if(!t2)
      YYERR_MSG_GOTO(err_Collection, "Collection: cannot create triple 2");

    if(raptor_sequence_push((yyval.formula)->triples, t2))
      YYERR_MSG_GOTO(err_Collection, "Collection: sequence push 2 failed");

    rasqal_free_literal(object);
    object=blank;
    blank=NULL;
  }

  /* free sequence of formulas just processed */
  raptor_free_sequence((yyvsp[(2) - (3)].seq));
  
  (yyval.formula)->value=object;
  
#if RASQAL_DEBUG > 1
  fprintf(DEBUG_FH, "  after substitution collection=");
  rasqal_formula_print((yyval.formula), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif

  rasqal_free_literal(first_identifier);
  rasqal_free_literal(rest_identifier);

  break; /* success */

  err_Collection:
  
  if(blank)
    rasqal_free_literal(blank);
  if(object)
    rasqal_free_literal(object);
  if(rest_identifier)
    rasqal_free_literal(rest_identifier);
  if(first_identifier)
    rasqal_free_literal(first_identifier);
  if((yyvsp[(2) - (3)].seq))
    raptor_free_sequence((yyvsp[(2) - (3)].seq));
  if((yyval.formula)) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula)=NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 133:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  char const *errmsg;

  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 1\n");
  if((yyvsp[(2) - (2)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(2) - (2)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
  if((yyvsp[(1) - (2)].seq)) {
    fprintf(DEBUG_FH, "  GraphNodeListNotEmpty=");
    raptor_sequence_print((yyvsp[(1) - (2)].seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else
    fprintf(DEBUG_FH, "  and empty GraphNodeListNotEmpty\n");
#endif

  (yyval.seq)=(yyvsp[(1) - (2)].seq);
  if(!(yyval.seq)) {
    (yyval.seq) = raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_formula, (raptor_sequence_print_handler*)rasqal_formula_print);
    if(!(yyval.seq))
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty, "GraphNodeListNotEmpty: cannot create formula");
  }
  
  if((yyvsp[(2) - (2)].formula)) {
    if(raptor_sequence_push((yyval.seq), (yyvsp[(2) - (2)].formula))) {
      YYERR_MSG_GOTO(err_GraphNodeListNotEmpty, "GraphNodeListNotEmpty 1: sequence push failed");
    }
    (yyvsp[(2) - (2)].formula) = NULL;
#if RASQAL_DEBUG > 1  
    fprintf(DEBUG_FH, "  itemList is now ");
    raptor_sequence_print((yyval.seq), DEBUG_FH);
    fprintf(DEBUG_FH, "\n\n");
#endif
  }

  break; /* success */

  err_GraphNodeListNotEmpty:
  if((yyvsp[(2) - (2)].formula))
    rasqal_free_formula((yyvsp[(2) - (2)].formula));
  if((yyval.seq)) {
    raptor_free_sequence((yyval.seq));
    (yyval.seq)=NULL;
  }
  YYERROR_MSG(errmsg);
}
    break;

  case 134:

/* Line 1455 of yacc.c  */

    {
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "GraphNodeListNotEmpty 2\n");
  if((yyvsp[(1) - (1)].formula)) {
    fprintf(DEBUG_FH, "  GraphNode=");
    rasqal_formula_print((yyvsp[(1) - (1)].formula), DEBUG_FH);
    fprintf(DEBUG_FH, "\n");
  } else  
    fprintf(DEBUG_FH, "  and empty GraphNode\n");
#endif

  if(!(yyvsp[(1) - (1)].formula))
    (yyval.seq)=NULL;
  else {
    (yyval.seq)=raptor_new_sequence((raptor_sequence_free_handler*)rasqal_free_formula, (raptor_sequence_print_handler*)rasqal_formula_print);
    if(!(yyval.seq)) {
      rasqal_free_formula((yyvsp[(1) - (1)].formula));
      YYERROR_MSG("GraphNodeListNotEmpty 2: cannot create sequence");
    }
    if(raptor_sequence_push((yyval.seq), (yyvsp[(1) - (1)].formula))) {
      raptor_free_sequence((yyval.seq));
      (yyval.seq)=NULL;
      YYERROR_MSG("GraphNodeListNotEmpty 2: sequence push failed");
    }
  }
#if RASQAL_DEBUG > 1  
  fprintf(DEBUG_FH, "  GraphNodeListNotEmpty is now ");
  raptor_sequence_print((yyval.seq), DEBUG_FH);
  fprintf(DEBUG_FH, "\n\n");
#endif
}
    break;

  case 135:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 136:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=(yyvsp[(1) - (1)].formula);
}
    break;

  case 137:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=rasqal_new_formula();
  if(!(yyval.formula))
    YYERROR_MSG("VarOrTerm 1: cannot create formula");
  (yyval.formula)->value=rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.formula)->value) {
    rasqal_free_formula((yyval.formula));
    (yyval.formula)=NULL;
    YYERROR_MSG("VarOrTerm 1: cannot create literal");
  }
}
    break;

  case 138:

/* Line 1455 of yacc.c  */

    {
  (yyval.formula)=rasqal_new_formula();
  if(!(yyval.formula)) {
    if((yyvsp[(1) - (1)].literal))
      rasqal_free_literal((yyvsp[(1) - (1)].literal));
    YYERROR_MSG("VarOrTerm 2: cannot create formula");
  }
  (yyval.formula)->value=(yyvsp[(1) - (1)].literal);
}
    break;

  case 139:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!(yyval.literal))
    YYERROR_MSG("VarOrIRIref: cannot create literal");
}
    break;

  case 140:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 141:

/* Line 1455 of yacc.c  */

    {
  (yyval.variable)=(yyvsp[(2) - (2)].variable);
}
    break;

  case 142:

/* Line 1455 of yacc.c  */

    {
  (yyval.variable)=(yyvsp[(2) - (2)].variable);
}
    break;

  case 143:

/* Line 1455 of yacc.c  */

    {
  (yyval.variable)=rasqal_new_variable((rasqal_query*)rq, (yyvsp[(1) - (1)].name), NULL);
  if(!(yyval.variable))
    YYERROR_MSG("VarName: cannot create var");
}
    break;

  case 144:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 145:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 146:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 147:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 148:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 149:

/* Line 1455 of yacc.c  */

    {
#ifdef RAPTOR_V2_AVAILABLE
  (yyval.literal)=rasqal_new_uri_literal(((rasqal_query*)rq)->world, raptor_uri_copy_v2(((rasqal_query*)rq)->world->raptor_world_ptr, ((rasqal_query*)rq)->world->rdf_nil_uri));
#else
  (yyval.literal)=rasqal_new_uri_literal(((rasqal_query*)rq)->world, raptor_uri_copy(((rasqal_query*)rq)->world->rdf_nil_uri));
#endif
  if(!(yyval.literal))
    YYERROR_MSG("GraphTerm: cannot create literal");
}
    break;

  case 150:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 151:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_OR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalOrExpression: cannot create expr");
}
    break;

  case 152:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 153:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_AND, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("ConditionalAndExpression: cannot create expr");
;
}
    break;

  case 154:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 155:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_EQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 1: cannot create expr");
}
    break;

  case 156:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_NEQ, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 2: cannot create expr");
}
    break;

  case 157:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_LT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 3: cannot create expr");
}
    break;

  case 158:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_GT, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 4: cannot create expr");
}
    break;

  case 159:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_LE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 5: cannot create expr");
}
    break;

  case 160:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_GE, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RelationalExpression 6: cannot create expr");
}
    break;

  case 161:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 162:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_PLUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 1: cannot create expr");
}
    break;

  case 163:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_MINUS, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 2: cannot create expr");
}
    break;

  case 164:

/* Line 1455 of yacc.c  */

    {
  rasqal_expression *e=rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 3: cannot create expr");
  }
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 4: cannot create expr");
}
    break;

  case 165:

/* Line 1455 of yacc.c  */

    {
  rasqal_expression *e=rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(2) - (2)].literal));
  if(!e) {
    rasqal_free_expression((yyvsp[(1) - (2)].expr));
    YYERROR_MSG("AdditiveExpression 5: cannot create expr");
  }
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_PLUS, (yyvsp[(1) - (2)].expr), e);
  if(!(yyval.expr))
    YYERROR_MSG("AdditiveExpression 6: cannot create expr");
}
    break;

  case 166:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 167:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_STAR, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 1: cannot create expr");
}
    break;

  case 168:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_SLASH, (yyvsp[(1) - (3)].expr), (yyvsp[(3) - (3)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("MultiplicativeExpression 2: cannot create expr");
}
    break;

  case 169:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 170:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_BANG, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 1: cannot create expr");
}
    break;

  case 171:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(2) - (2)].expr);
}
    break;

  case 172:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_UMINUS, (yyvsp[(2) - (2)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("UnaryExpression 3: cannot create expr");
}
    break;

  case 173:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 174:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 175:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 176:

/* Line 1455 of yacc.c  */

    {
  /* Grammar has IRIrefOrFunction here which is "IRIref ArgList?"
   * and essentially shorthand for FunctionCall | IRIref.  The Rasqal
   * SPARQL lexer distinguishes these for us with IRIrefBrace.
   * IRIref is covered below by GraphTerm.
   */
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 177:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_literal_expression(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].literal));
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 4: cannot create expr");
}
    break;

  case 178:

/* Line 1455 of yacc.c  */

    {
  rasqal_literal *l=rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].variable));
  if(!l)
    YYERROR_MSG("PrimaryExpression 5: cannot create literal");
  (yyval.expr)=rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!(yyval.expr))
    YYERROR_MSG("PrimaryExpression 5: cannot create expr");
}
    break;

  case 179:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(2) - (3)].expr);
}
    break;

  case 180:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_STR, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 1: cannot create expr");
}
    break;

  case 181:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_LANG, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 2: cannot create expr");
}
    break;

  case 182:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_LANGMATCHES, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 3: cannot create expr");
}
    break;

  case 183:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_DATATYPE, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 4: cannot create expr");
}
    break;

  case 184:

/* Line 1455 of yacc.c  */

    {
  rasqal_literal *l;
  rasqal_expression *e;
  l=rasqal_new_variable_literal(((rasqal_query*)rq)->world, (yyvsp[(3) - (4)].variable));
  if(!l)
    YYERROR_MSG("BuiltInCall 5: cannot create literal");
  e=rasqal_new_literal_expression(((rasqal_query*)rq)->world, l);
  if(!e)
    YYERROR_MSG("BuiltInCall 6: cannot create literal expr");
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_BOUND, e);
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 7: cannot create expr");
}
    break;

  case 185:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_2op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_SAMETERM, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 8: cannot create expr");
}
    break;

  case 186:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ISURI, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 9: cannot create expr");
}
    break;

  case 187:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ISBLANK, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 10: cannot create expr");
}
    break;

  case 188:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_1op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_ISLITERAL, (yyvsp[(3) - (4)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("BuiltInCall 11: cannot create expr");
}
    break;

  case 189:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 190:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=(yyvsp[(1) - (1)].expr);
}
    break;

  case 191:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_3op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_REGEX, (yyvsp[(3) - (6)].expr), (yyvsp[(5) - (6)].expr), NULL);
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 1: cannot create expr");
}
    break;

  case 192:

/* Line 1455 of yacc.c  */

    {
  (yyval.expr)=rasqal_new_3op_expression(((rasqal_query*)rq)->world, RASQAL_EXPR_REGEX, (yyvsp[(3) - (8)].expr), (yyvsp[(5) - (8)].expr), (yyvsp[(7) - (8)].expr));
  if(!(yyval.expr))
    YYERROR_MSG("RegexExpression 2: cannot create expr");
}
    break;

  case 193:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 1: cannot create literal");
}
    break;

  case 194:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIrefBrace 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal)=NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 195:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 196:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 197:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 198:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 199:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 200:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 201:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 202:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 203:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 204:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 205:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 206:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=(yyvsp[(1) - (1)].literal);
}
    break;

  case 207:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=rasqal_new_uri_literal(((rasqal_query*)rq)->world, (yyvsp[(1) - (1)].uri));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 1: cannot create literal");
}
    break;

  case 208:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_QNAME, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("IRIref 2: cannot create literal");
  if(rasqal_literal_expand_qname((rasqal_query*)rq, (yyval.literal))) {
    sparql_query_error_full((rasqal_query*)rq,
                            "QName %s cannot be expanded", (yyvsp[(1) - (1)].name));
    rasqal_free_literal((yyval.literal));
    (yyval.literal)=NULL;
    YYERROR_MSG("IRIrefBrace 2: cannot expand qname");
  }
}
    break;

  case 209:

/* Line 1455 of yacc.c  */

    {
  (yyval.literal)=rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, (yyvsp[(1) - (1)].name));
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 1: cannot create literal");
}
    break;

  case 210:

/* Line 1455 of yacc.c  */

    {
  const unsigned char *id=rasqal_query_generate_bnodeid((rasqal_query*)rq, NULL);
  if(!id)
    YYERROR_MSG("BlankNode 2: cannot create bnodeid");
  (yyval.literal)=rasqal_new_simple_literal(((rasqal_query*)rq)->world, RASQAL_LITERAL_BLANK, id);
  if(!(yyval.literal))
    YYERROR_MSG("BlankNode 2: cannot create literal");
}
    break;



/* Line 1455 of yacc.c  */

      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct (YYPARSE_PARAM, "Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct (YYPARSE_PARAM, "Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct (YYPARSE_PARAM, "Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct (YYPARSE_PARAM, "Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */




/* Support functions */


/* This is declared in sparql_lexer.h but never used, so we always get
 * a warning unless this dummy code is here.  Used once below in an error case.
 */
static int yy_init_globals (yyscan_t yyscanner ) { return 0; }


/**
 * rasqal_sparql_query_language_init - Initialise the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static int
rasqal_sparql_query_language_init(rasqal_query* rdf_query, const char *name) {
  rasqal_sparql_query_language* rqe=(rasqal_sparql_query_language*)rdf_query->context;

  rdf_query->compare_flags = RASQAL_COMPARE_XQUERY;

  rqe->extended = (strcmp(name, "laqrs") == 0);
  return 0;
}


/**
 * rasqal_sparql_query_language_terminate - Free the SPARQL query language parser
 *
 * Return value: non 0 on failure
 **/
static void
rasqal_sparql_query_language_terminate(rasqal_query* rdf_query) {
  rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)rdf_query->context;

  if(sparql && sparql->scanner_set) {
    sparql_lexer_lex_destroy(sparql->scanner);
    sparql->scanner_set=0;
  }

}


static int
rasqal_sparql_query_language_prepare(rasqal_query* rdf_query) {
  /* rasqal_sparql_query_language* sparql=(rasqal_sparql_query_language*)rdf_query->context; */
  int rc;
  
  if(!rdf_query->query_string)
    return 1;
  
  rc=sparql_parse(rdf_query);
  if(rc)
    return rc;

  /* FIXME - should check remaining query parts  */
  if(rasqal_sequence_has_qname(rdf_query->triples) ||
     rasqal_sequence_has_qname(rdf_query->constructs) ||
     rasqal_query_constraints_has_qname(rdf_query)) {
    sparql_query_error(rdf_query, "SPARQL query has unexpanded QNames");
    return 1;
  }

  /* SPARQL: Turn [] into anonymous variables */
  if(rasqal_query_build_anonymous_variables(rdf_query))
    return 1;
  
  /* SPARQL: Expand 'SELECT *' */
  if(rasqal_query_expand_wildcards(rdf_query))
    return 1;
  
  return 0;
}


static int
sparql_parse(rasqal_query* rq) {
  rasqal_sparql_query_language* rqe=(rasqal_sparql_query_language*)rq->context;
  raptor_locator *locator=&rq->locator;
  void *buffer;

  if(!rq->query_string)
    return yy_init_globals(NULL); /* 0 but a way to use yy_init_globals */

  locator->line=1;
  locator->column= -1; /* No column info */
  locator->byte= -1; /* No bytes info */

#if RASQAL_DEBUG > 2
  sparql_parser_debug=1;
#endif

  rqe->lineno=1;

  if(sparql_lexer_lex_init(&rqe->scanner))
    return 1;
  rqe->scanner_set=1;

  sparql_lexer_set_extra(((rasqal_query*)rq), rqe->scanner);

  buffer= sparql_lexer__scan_buffer((char*)rq->query_string, rq->query_string_length, rqe->scanner);

  rqe->error_count=0;

  sparql_parser_parse(rq);

  sparql_lexer_lex_destroy(rqe->scanner);
  rqe->scanner_set=0;

  /* Parsing failed */
  if(rq->failed)
    return 1;
  
  return 0;
}


static void
sparql_query_error(rasqal_query *rq, const char *msg) {
  rasqal_sparql_query_language* rqe=(rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  rq->failed=1;
  rasqal_log_error_simple(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR, &rq->locator,
                          "%s", msg);
}


static void
sparql_query_error_full(rasqal_query *rq, const char *message, ...) {
  va_list arguments;
  rasqal_sparql_query_language* rqe=(rasqal_sparql_query_language*)rq->context;

  if(rqe->error_count++)
    return;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);

  rq->failed=1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR, &rq->locator,
                           message, arguments);

  va_end(arguments);
}


int
sparql_syntax_error(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe=(rasqal_sparql_query_language*)rq->context;
  va_list arguments;

  if(rqe->error_count++)
    return 0;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rp->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rq->failed=1;
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_ERROR, &rq->locator,
                           message, arguments);
  va_end(arguments);

  return 0;
}


int
sparql_syntax_warning(rasqal_query *rq, const char *message, ...)
{
  rasqal_sparql_query_language *rqe=(rasqal_sparql_query_language*)rq->context;
  va_list arguments;

  rq->locator.line=rqe->lineno;
#ifdef RASQAL_SPARQL_USE_ERROR_COLUMNS
  /*  rq->locator.column=sparql_lexer_get_column(yyscanner);*/
#endif

  va_start(arguments, message);
  rasqal_log_error_varargs(((rasqal_query*)rq)->world, RAPTOR_LOG_LEVEL_WARNING, &rq->locator,
                           message, arguments);
  va_end(arguments);

  return (0);
}


static int
rasqal_sparql_query_language_iostream_write_escaped_counted_string(rasqal_query* query,
                                                                 raptor_iostream* iostr,
                                                                 const unsigned char* string,
                                                                 size_t len)
{
  const char delim='"';
  
  raptor_iostream_write_byte(iostr, delim);
  if(raptor_iostream_write_string_ntriples(iostr, string, len, delim))
    return 1;
  
  raptor_iostream_write_byte(iostr, delim);

  return 0;
}


static void
rasqal_sparql_query_language_register_factory(rasqal_query_language_factory *factory)
{
  factory->context_length = sizeof(rasqal_sparql_query_language);

  factory->init      = rasqal_sparql_query_language_init;
  factory->terminate = rasqal_sparql_query_language_terminate;
  factory->prepare   = rasqal_sparql_query_language_prepare;
  factory->iostream_write_escaped_counted_string = rasqal_sparql_query_language_iostream_write_escaped_counted_string;
}


int
rasqal_init_query_language_sparql(rasqal_world* world) {
  return rasqal_query_language_register_factory(world,
                                                "sparql", 
                                                "SPARQL W3C DAWG RDF Query Language",
                                                NULL,
                                                (const unsigned char*)"http://www.w3.org/TR/rdf-sparql-query/",
                                                &rasqal_sparql_query_language_register_factory);
}

int
rasqal_init_query_language_laqrs(rasqal_world* world) {
  return rasqal_query_language_register_factory(world,
                                                "laqrs", 
                                                "LAQRS adds to Querying RDF in SPARQL",
                                                NULL,
                                                NULL,
                                                &rasqal_sparql_query_language_register_factory);
}


#ifdef STANDALONE
#include <stdio.h>
#include <locale.h>
#ifdef HAVE_GETOPT_H
#include <getopt.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifndef HAVE_GETOPT
#include <rasqal_getopt.h>
#endif

#ifdef NEED_OPTIND_DECLARATION
extern int optind;
extern char *optarg;
#endif

#define GETOPT_STRING "di:"

#define SPARQL_FILE_BUF_SIZE 2048

int
main(int argc, char *argv[]) 
{
  const char *program=rasqal_basename(argv[0]);
  char query_string[SPARQL_FILE_BUF_SIZE];
  rasqal_query *query;
  FILE *fh;
  int rc;
  const char *filename=NULL;
  raptor_uri* base_uri=NULL;
  unsigned char *uri_string;
  const char* query_languages[2]={"sparql", "laqrs"};
  const char* query_language;
  int usage=0;
  rasqal_world *world;
  
  query_language=query_languages[0];
  
  filename = getenv("SPARQL_QUERY_FILE");
    
  while(!usage) {
    int c = getopt (argc, argv, GETOPT_STRING);

    if (c == -1)
      break;

    switch (c) {
      case 0:
      case '?': /* getopt() - unknown option */
        usage=1;
        break;
        
      case 'd':
#if RASQAL_DEBUG > 2
        sparql_parser_debug=1;
#endif
        break;
  
      case 'i':
        if(optarg) {
          if(!strcmp(optarg, "laqrs")) {
            query_language=query_languages[1];
          } else if(!strcmp(optarg, "sparql")) {
            query_language=query_languages[0];
          } else {
            fprintf(stderr, "-i laqrs or -i sparql only\n");
            usage=1;
          }
        }
        break;
    }
  }

  if(!filename) {
    if((argc-optind) != 1) {
      fprintf(stderr, "%s: Too many arguments.\n", program);
      usage=1;
    } else
      filename=argv[optind];
  }
  
  if(usage) {
    fprintf(stderr, "SPARQL/LAQRS parser test for Rasqal %s\n", 
            rasqal_version_string);
    fprintf(stderr, "USAGE: %s [OPTIONS] SPARQL-QUERY-FILE\n", program);
    fprintf(stderr, "OPTIONS:\n");
#if RASQAL_DEBUG > 2
    fprintf(stderr, " -d           Bison parser debugging\n");
#endif
    fprintf(stderr, " -i LANGUAGE  Set query language\n");
    exit(1);
  }


 fh = fopen(filename, "r");
 if(!fh) {
   fprintf(stderr, "%s: Cannot open file %s - %s\n", program, filename,
           strerror(errno));
   exit(1);
 }
 
  memset(query_string, 0, SPARQL_FILE_BUF_SIZE);
  rc=fread(query_string, SPARQL_FILE_BUF_SIZE, 1, fh);
  if(rc < SPARQL_FILE_BUF_SIZE) {
    if(ferror(fh)) {
      fprintf(stderr, "%s: file '%s' read failed - %s\n",
              program, filename, strerror(errno));
      fclose(fh);
      return(1);
    }
  }
  
  fclose(fh);

  world=rasqal_new_world();
  if(!world || rasqal_world_open(world))
    exit(1);

  query=rasqal_new_query(world, query_language, NULL);

  uri_string=raptor_uri_filename_to_uri_string(filename);
#ifdef RAPTOR_V2_AVAILABLE
  base_uri = raptor_new_uri_v2(world->raptor_world_ptr, uri_string);
#else
  base_uri = raptor_new_uri(uri_string);
#endif

  rc=rasqal_query_prepare(query, (const unsigned char*)query_string, base_uri);

  rasqal_query_print(query, stdout);

  rasqal_free_query(query);

#ifdef RAPTOR_V2_AVAILABLE
  raptor_free_uri_v2(world->raptor_world_ptr, base_uri);
#else
  raptor_free_uri(base_uri);
#endif

  raptor_free_memory(uri_string);

  rasqal_free_world(world);

  return rc;
}
#endif

